module Humanize
  class Az
    POINT = "vergül".freeze
    INFINITY = 'sonsuz'.freeze
    UNDEFINED = 'undefined'.freeze
    NEGATIVE = 'mənfi'.freeze
    LOTS = [nil, 'min', 'milyon', 'milyard', 'trilyon', 'katrilyon', 'kentilyon', 'seksilyon', 'septilyon', 'oktilyon', 'nonilyon', 'desilyon', 'undesilyon', 'dodesilyon', 'tredesilyon', 'katordesilyon', 'kendesilyon', 'seksdesilyon', 'septendesilyon', 'oktodesilyon', 'novemdesilyon', 'vigintilyon'].freeze
    SUB_ONE_GROUPING = ["sıfır", "bir", "iki", "üç", "dört", "beş", "altı", "yeddi", "səkkiz", "doqquz", "on", "on bir", "on iki", "on üç", "on dört", "on beş", "on altı", "on yeddi", "on səkkiz", "on doqquz", "yirmi", "yirmi bir", "yirmi iki", "yirmi üç", "yirmi dört", "yirmi beş", "yirmi altı", "yirmi yeddi", "yirmi səkkiz", "yirmi doqquz", "otuz", "otuz bir", "otuz iki", "otuz üç", "otuz dört", "otuz beş", "otuz altı", "otuz yeddi", "otuz səkkiz", "otuz doqquz", "qırx", "qırx bir", "qırx iki", "qırx üç", "qırx dört", "qırx beş", "qırx altı", "qırx yeddi", "qırx səkkiz", "qırx doqquz", "əlli", "əlli bir", "əlli iki", "əlli üç", "əlli dört", "əlli beş", "əlli altı", "əlli yeddi", "əlli səkkiz", "əlli doqquz", "altmış", "altmış bir", "altmış iki", "altmış üç", "altmış dört", "altmış beş", "altmış altı", "altmış yeddi", "altmış səkkiz", "altmış doqquz", "yetmiş", "yetmiş bir", "yetmiş iki", "yetmiş üç", "yetmiş dört", "yetmiş beş", "yetmiş altı", "yetmiş yeddi", "yetmiş səkkiz", "yetmiş doqquz", "səksən", "səksən bir", "səksən iki", "səksən üç", "səksən dört", "səksən beş", "səksən altı", "səksən yeddi", "səksən səkkiz", "səksən doqquz", "doxsan", "doxsan bir", "doxsan iki", "doxsan üç", "doxsan dört", "doxsan beş", "doxsan altı", "doxsan yeddi", "doxsan səkkiz", "doxsan doqquz", "yüz", "yüz bir", "yüz iki", "yüz üç", "yüz dört", "yüz beş", "yüz altı", "yüz yeddi", "yüz səkkiz", "yüz doqquz", "yüz on", "yüz on bir", "yüz on iki", "yüz on üç", "yüz on dört", "yüz on beş", "yüz on altı", "yüz on yeddi", "yüz on səkkiz", "yüz on doqquz", "yüz yirmi", "yüz yirmi bir", "yüz yirmi iki", "yüz yirmi üç", "yüz yirmi dört", "yüz yirmi beş", "yüz yirmi altı", "yüz yirmi yeddi", "yüz yirmi səkkiz", "yüz yirmi doqquz", "yüz otuz", "yüz otuz bir", "yüz otuz iki", "yüz otuz üç", "yüz otuz dört", "yüz otuz beş", "yüz otuz altı", "yüz otuz yeddi", "yüz otuz səkkiz", "yüz otuz doqquz", "yüz qırx", "yüz qırx bir", "yüz qırx iki", "yüz qırx üç", "yüz qırx dört", "yüz qırx beş", "yüz qırx altı", "yüz qırx yeddi", "yüz qırx səkkiz", "yüz qırx doqquz", "yüz əlli", "yüz əlli bir", "yüz əlli iki", "yüz əlli üç", "yüz əlli dört", "yüz əlli beş", "yüz əlli altı", "yüz əlli yeddi", "yüz əlli səkkiz", "yüz əlli doqquz", "yüz altmış", "yüz altmış bir", "yüz altmış iki", "yüz altmış üç", "yüz altmış dört", "yüz altmış beş", "yüz altmış altı", "yüz altmış yeddi", "yüz altmış səkkiz", "yüz altmış doqquz", "yüz yetmiş", "yüz yetmiş bir", "yüz yetmiş iki", "yüz yetmiş üç", "yüz yetmiş dört", "yüz yetmiş beş", "yüz yetmiş altı", "yüz yetmiş yeddi", "yüz yetmiş səkkiz", "yüz yetmiş doqquz", "yüz səksən", "yüz səksən bir", "yüz səksən iki", "yüz səksən üç", "yüz səksən dört", "yüz səksən beş", "yüz səksən altı", "yüz səksən yeddi", "yüz səksən səkkiz", "yüz səksən doqquz", "yüz doxsan", "yüz doxsan bir", "yüz doxsan iki", "yüz doxsan üç", "yüz doxsan dört", "yüz doxsan beş", "yüz doxsan altı", "yüz doxsan yeddi", "yüz doxsan səkkiz", "yüz doxsan doqquz", "iki yüz", "iki yüz bir", "iki yüz iki", "iki yüz üç", "iki yüz dört", "iki yüz beş", "iki yüz altı", "iki yüz yeddi", "iki yüz səkkiz", "iki yüz doqquz", "iki yüz on", "iki yüz on bir", "iki yüz on iki", "iki yüz on üç", "iki yüz on dört", "iki yüz on beş", "iki yüz on altı", "iki yüz on yeddi", "iki yüz on səkkiz", "iki yüz on doqquz", "iki yüz yirmi", "iki yüz yirmi bir", "iki yüz yirmi iki", "iki yüz yirmi üç", "iki yüz yirmi dört", "iki yüz yirmi beş", "iki yüz yirmi altı", "iki yüz yirmi yeddi", "iki yüz yirmi səkkiz", "iki yüz yirmi doqquz", "iki yüz otuz", "iki yüz otuz bir", "iki yüz otuz iki", "iki yüz otuz üç", "iki yüz otuz dört", "iki yüz otuz beş", "iki yüz otuz altı", "iki yüz otuz yeddi", "iki yüz otuz səkkiz", "iki yüz otuz doqquz", "iki yüz qırx", "iki yüz qırx bir", "iki yüz qırx iki", "iki yüz qırx üç", "iki yüz qırx dört", "iki yüz qırx beş", "iki yüz qırx altı", "iki yüz qırx yeddi", "iki yüz qırx səkkiz", "iki yüz qırx doqquz", "iki yüz əlli", "iki yüz əlli bir", "iki yüz əlli iki", "iki yüz əlli üç", "iki yüz əlli dört", "iki yüz əlli beş", "iki yüz əlli altı", "iki yüz əlli yeddi", "iki yüz əlli səkkiz", "iki yüz əlli doqquz", "iki yüz altmış", "iki yüz altmış bir", "iki yüz altmış iki", "iki yüz altmış üç", "iki yüz altmış dört", "iki yüz altmış beş", "iki yüz altmış altı", "iki yüz altmış yeddi", "iki yüz altmış səkkiz", "iki yüz altmış doqquz", "iki yüz yetmiş", "iki yüz yetmiş bir", "iki yüz yetmiş iki", "iki yüz yetmiş üç", "iki yüz yetmiş dört", "iki yüz yetmiş beş", "iki yüz yetmiş altı", "iki yüz yetmiş yeddi", "iki yüz yetmiş səkkiz", "iki yüz yetmiş doqquz", "iki yüz səksən", "iki yüz səksən bir", "iki yüz səksən iki", "iki yüz səksən üç", "iki yüz səksən dört", "iki yüz səksən beş", "iki yüz səksən altı", "iki yüz səksən yeddi", "iki yüz səksən səkkiz", "iki yüz səksən doqquz", "iki yüz doxsan", "iki yüz doxsan bir", "iki yüz doxsan iki", "iki yüz doxsan üç", "iki yüz doxsan dört", "iki yüz doxsan beş", "iki yüz doxsan altı", "iki yüz doxsan yeddi", "iki yüz doxsan səkkiz", "iki yüz doxsan doqquz", "üç yüz", "üç yüz bir", "üç yüz iki", "üç yüz üç", "üç yüz dört", "üç yüz beş", "üç yüz altı", "üç yüz yeddi", "üç yüz səkkiz", "üç yüz doqquz", "üç yüz on", "üç yüz on bir", "üç yüz on iki", "üç yüz on üç", "üç yüz on dört", "üç yüz on beş", "üç yüz on altı", "üç yüz on yeddi", "üç yüz on səkkiz", "üç yüz on doqquz", "üç yüz yirmi", "üç yüz yirmi bir", "üç yüz yirmi iki", "üç yüz yirmi üç", "üç yüz yirmi dört", "üç yüz yirmi beş", "üç yüz yirmi altı", "üç yüz yirmi yeddi", "üç yüz yirmi səkkiz", "üç yüz yirmi doqquz", "üç yüz otuz", "üç yüz otuz bir", "üç yüz otuz iki", "üç yüz otuz üç", "üç yüz otuz dört", "üç yüz otuz beş", "üç yüz otuz altı", "üç yüz otuz yeddi", "üç yüz otuz səkkiz", "üç yüz otuz doqquz", "üç yüz qırx", "üç yüz qırx bir", "üç yüz qırx iki", "üç yüz qırx üç", "üç yüz qırx dört", "üç yüz qırx beş", "üç yüz qırx altı", "üç yüz qırx yeddi", "üç yüz qırx səkkiz", "üç yüz qırx doqquz", "üç yüz əlli", "üç yüz əlli bir", "üç yüz əlli iki", "üç yüz əlli üç", "üç yüz əlli dört", "üç yüz əlli beş", "üç yüz əlli altı", "üç yüz əlli yeddi", "üç yüz əlli səkkiz", "üç yüz əlli doqquz", "üç yüz altmış", "üç yüz altmış bir", "üç yüz altmış iki", "üç yüz altmış üç", "üç yüz altmış dört", "üç yüz altmış beş", "üç yüz altmış altı", "üç yüz altmış yeddi", "üç yüz altmış səkkiz", "üç yüz altmış doqquz", "üç yüz yetmiş", "üç yüz yetmiş bir", "üç yüz yetmiş iki", "üç yüz yetmiş üç", "üç yüz yetmiş dört", "üç yüz yetmiş beş", "üç yüz yetmiş altı", "üç yüz yetmiş yeddi", "üç yüz yetmiş səkkiz", "üç yüz yetmiş doqquz", "üç yüz səksən", "üç yüz səksən bir", "üç yüz səksən iki", "üç yüz səksən üç", "üç yüz səksən dört", "üç yüz səksən beş", "üç yüz səksən altı", "üç yüz səksən yeddi", "üç yüz səksən səkkiz", "üç yüz səksən doqquz", "üç yüz doxsan", "üç yüz doxsan bir", "üç yüz doxsan iki", "üç yüz doxsan üç", "üç yüz doxsan dört", "üç yüz doxsan beş", "üç yüz doxsan altı", "üç yüz doxsan yeddi", "üç yüz doxsan səkkiz", "üç yüz doxsan doqquz", "dört yüz", "dört yüz bir", "dört yüz iki", "dört yüz üç", "dört yüz dört", "dört yüz beş", "dört yüz altı", "dört yüz yeddi", "dört yüz səkkiz", "dört yüz doqquz", "dört yüz on", "dört yüz on bir", "dört yüz on iki", "dört yüz on üç", "dört yüz on dört", "dört yüz on beş", "dört yüz on altı", "dört yüz on yeddi", "dört yüz on səkkiz", "dört yüz on doqquz", "dört yüz yirmi", "dört yüz yirmi bir", "dört yüz yirmi iki", "dört yüz yirmi üç", "dört yüz yirmi dört", "dört yüz yirmi beş", "dört yüz yirmi altı", "dört yüz yirmi yeddi", "dört yüz yirmi səkkiz", "dört yüz yirmi doqquz", "dört yüz otuz", "dört yüz otuz bir", "dört yüz otuz iki", "dört yüz otuz üç", "dört yüz otuz dört", "dört yüz otuz beş", "dört yüz otuz altı", "dört yüz otuz yeddi", "dört yüz otuz səkkiz", "dört yüz otuz doqquz", "dört yüz qırx", "dört yüz qırx bir", "dört yüz qırx iki", "dört yüz qırx üç", "dört yüz qırx dört", "dört yüz qırx beş", "dört yüz qırx altı", "dört yüz qırx yeddi", "dört yüz qırx səkkiz", "dört yüz qırx doqquz", "dört yüz əlli", "dört yüz əlli bir", "dört yüz əlli iki", "dört yüz əlli üç", "dört yüz əlli dört", "dört yüz əlli beş", "dört yüz əlli altı", "dört yüz əlli yeddi", "dört yüz əlli səkkiz", "dört yüz əlli doqquz", "dört yüz altmış", "dört yüz altmış bir", "dört yüz altmış iki", "dört yüz altmış üç", "dört yüz altmış dört", "dört yüz altmış beş", "dört yüz altmış altı", "dört yüz altmış yeddi", "dört yüz altmış səkkiz", "dört yüz altmış doqquz", "dört yüz yetmiş", "dört yüz yetmiş bir", "dört yüz yetmiş iki", "dört yüz yetmiş üç", "dört yüz yetmiş dört", "dört yüz yetmiş beş", "dört yüz yetmiş altı", "dört yüz yetmiş yeddi", "dört yüz yetmiş səkkiz", "dört yüz yetmiş doqquz", "dört yüz səksən", "dört yüz səksən bir", "dört yüz səksən iki", "dört yüz səksən üç", "dört yüz səksən dört", "dört yüz səksən beş", "dört yüz səksən altı", "dört yüz səksən yeddi", "dört yüz səksən səkkiz", "dört yüz səksən doqquz", "dört yüz doxsan", "dört yüz doxsan bir", "dört yüz doxsan iki", "dört yüz doxsan üç", "dört yüz doxsan dört", "dört yüz doxsan beş", "dört yüz doxsan altı", "dört yüz doxsan yeddi", "dört yüz doxsan səkkiz", "dört yüz doxsan doqquz", "beş yüz", "beş yüz bir", "beş yüz iki", "beş yüz üç", "beş yüz dört", "beş yüz beş", "beş yüz altı", "beş yüz yeddi", "beş yüz səkkiz", "beş yüz doqquz", "beş yüz on", "beş yüz on bir", "beş yüz on iki", "beş yüz on üç", "beş yüz on dört", "beş yüz on beş", "beş yüz on altı", "beş yüz on yeddi", "beş yüz on səkkiz", "beş yüz on doqquz", "beş yüz yirmi", "beş yüz yirmi bir", "beş yüz yirmi iki", "beş yüz yirmi üç", "beş yüz yirmi dört", "beş yüz yirmi beş", "beş yüz yirmi altı", "beş yüz yirmi yeddi", "beş yüz yirmi səkkiz", "beş yüz yirmi doqquz", "beş yüz otuz", "beş yüz otuz bir", "beş yüz otuz iki", "beş yüz otuz üç", "beş yüz otuz dört", "beş yüz otuz beş", "beş yüz otuz altı", "beş yüz otuz yeddi", "beş yüz otuz səkkiz", "beş yüz otuz doqquz", "beş yüz qırx", "beş yüz qırx bir", "beş yüz qırx iki", "beş yüz qırx üç", "beş yüz qırx dört", "beş yüz qırx beş", "beş yüz qırx altı", "beş yüz qırx yeddi", "beş yüz qırx səkkiz", "beş yüz qırx doqquz", "beş yüz əlli", "beş yüz əlli bir", "beş yüz əlli iki", "beş yüz əlli üç", "beş yüz əlli dört", "beş yüz əlli beş", "beş yüz əlli altı", "beş yüz əlli yeddi", "beş yüz əlli səkkiz", "beş yüz əlli doqquz", "beş yüz altmış", "beş yüz altmış bir", "beş yüz altmış iki", "beş yüz altmış üç", "beş yüz altmış dört", "beş yüz altmış beş", "beş yüz altmış altı", "beş yüz altmış yeddi", "beş yüz altmış səkkiz", "beş yüz altmış doqquz", "beş yüz yetmiş", "beş yüz yetmiş bir", "beş yüz yetmiş iki", "beş yüz yetmiş üç", "beş yüz yetmiş dört", "beş yüz yetmiş beş", "beş yüz yetmiş altı", "beş yüz yetmiş yeddi", "beş yüz yetmiş səkkiz", "beş yüz yetmiş doqquz", "beş yüz səksən", "beş yüz səksən bir", "beş yüz səksən iki", "beş yüz səksən üç", "beş yüz səksən dört", "beş yüz səksən beş", "beş yüz səksən altı", "beş yüz səksən yeddi", "beş yüz səksən səkkiz", "beş yüz səksən doqquz", "beş yüz doxsan", "beş yüz doxsan bir", "beş yüz doxsan iki", "beş yüz doxsan üç", "beş yüz doxsan dört", "beş yüz doxsan beş", "beş yüz doxsan altı", "beş yüz doxsan yeddi", "beş yüz doxsan səkkiz", "beş yüz doxsan doqquz", "altı yüz", "altı yüz bir", "altı yüz iki", "altı yüz üç", "altı yüz dört", "altı yüz beş", "altı yüz altı", "altı yüz yeddi", "altı yüz səkkiz", "altı yüz doqquz", "altı yüz on", "altı yüz on bir", "altı yüz on iki", "altı yüz on üç", "altı yüz on dört", "altı yüz on beş", "altı yüz on altı", "altı yüz on yeddi", "altı yüz on səkkiz", "altı yüz on doqquz", "altı yüz yirmi", "altı yüz yirmi bir", "altı yüz yirmi iki", "altı yüz yirmi üç", "altı yüz yirmi dört", "altı yüz yirmi beş", "altı yüz yirmi altı", "altı yüz yirmi yeddi", "altı yüz yirmi səkkiz", "altı yüz yirmi doqquz", "altı yüz otuz", "altı yüz otuz bir", "altı yüz otuz iki", "altı yüz otuz üç", "altı yüz otuz dört", "altı yüz otuz beş", "altı yüz otuz altı", "altı yüz otuz yeddi", "altı yüz otuz səkkiz", "altı yüz otuz doqquz", "altı yüz qırx", "altı yüz qırx bir", "altı yüz qırx iki", "altı yüz qırx üç", "altı yüz qırx dört", "altı yüz qırx beş", "altı yüz qırx altı", "altı yüz qırx yeddi", "altı yüz qırx səkkiz", "altı yüz qırx doqquz", "altı yüz əlli", "altı yüz əlli bir", "altı yüz əlli iki", "altı yüz əlli üç", "altı yüz əlli dört", "altı yüz əlli beş", "altı yüz əlli altı", "altı yüz əlli yeddi", "altı yüz əlli səkkiz", "altı yüz əlli doqquz", "altı yüz altmış", "altı yüz altmış bir", "altı yüz altmış iki", "altı yüz altmış üç", "altı yüz altmış dört", "altı yüz altmış beş", "altı yüz altmış altı", "altı yüz altmış yeddi", "altı yüz altmış səkkiz", "altı yüz altmış doqquz", "altı yüz yetmiş", "altı yüz yetmiş bir", "altı yüz yetmiş iki", "altı yüz yetmiş üç", "altı yüz yetmiş dört", "altı yüz yetmiş beş", "altı yüz yetmiş altı", "altı yüz yetmiş yeddi", "altı yüz yetmiş səkkiz", "altı yüz yetmiş doqquz", "altı yüz səksən", "altı yüz səksən bir", "altı yüz səksən iki", "altı yüz səksən üç", "altı yüz səksən dört", "altı yüz səksən beş", "altı yüz səksən altı", "altı yüz səksən yeddi", "altı yüz səksən səkkiz", "altı yüz səksən doqquz", "altı yüz doxsan", "altı yüz doxsan bir", "altı yüz doxsan iki", "altı yüz doxsan üç", "altı yüz doxsan dört", "altı yüz doxsan beş", "altı yüz doxsan altı", "altı yüz doxsan yeddi", "altı yüz doxsan səkkiz", "altı yüz doxsan doqquz", "yeddi yüz", "yeddi yüz bir", "yeddi yüz iki", "yeddi yüz üç", "yeddi yüz dört", "yeddi yüz beş", "yeddi yüz altı", "yeddi yüz yeddi", "yeddi yüz səkkiz", "yeddi yüz doqquz", "yeddi yüz on", "yeddi yüz on bir", "yeddi yüz on iki", "yeddi yüz on üç", "yeddi yüz on dört", "yeddi yüz on beş", "yeddi yüz on altı", "yeddi yüz on yeddi", "yeddi yüz on səkkiz", "yeddi yüz on doqquz", "yeddi yüz yirmi", "yeddi yüz yirmi bir", "yeddi yüz yirmi iki", "yeddi yüz yirmi üç", "yeddi yüz yirmi dört", "yeddi yüz yirmi beş", "yeddi yüz yirmi altı", "yeddi yüz yirmi yeddi", "yeddi yüz yirmi səkkiz", "yeddi yüz yirmi doqquz", "yeddi yüz otuz", "yeddi yüz otuz bir", "yeddi yüz otuz iki", "yeddi yüz otuz üç", "yeddi yüz otuz dört", "yeddi yüz otuz beş", "yeddi yüz otuz altı", "yeddi yüz otuz yeddi", "yeddi yüz otuz səkkiz", "yeddi yüz otuz doqquz", "yeddi yüz qırx", "yeddi yüz qırx bir", "yeddi yüz qırx iki", "yeddi yüz qırx üç", "yeddi yüz qırx dört", "yeddi yüz qırx beş", "yeddi yüz qırx altı", "yeddi yüz qırx yeddi", "yeddi yüz qırx səkkiz", "yeddi yüz qırx doqquz", "yeddi yüz əlli", "yeddi yüz əlli bir", "yeddi yüz əlli iki", "yeddi yüz əlli üç", "yeddi yüz əlli dört", "yeddi yüz əlli beş", "yeddi yüz əlli altı", "yeddi yüz əlli yeddi", "yeddi yüz əlli səkkiz", "yeddi yüz əlli doqquz", "yeddi yüz altmış", "yeddi yüz altmış bir", "yeddi yüz altmış iki", "yeddi yüz altmış üç", "yeddi yüz altmış dört", "yeddi yüz altmış beş", "yeddi yüz altmış altı", "yeddi yüz altmış yeddi", "yeddi yüz altmış səkkiz", "yeddi yüz altmış doqquz", "yeddi yüz yetmiş", "yeddi yüz yetmiş bir", "yeddi yüz yetmiş iki", "yeddi yüz yetmiş üç", "yeddi yüz yetmiş dört", "yeddi yüz yetmiş beş", "yeddi yüz yetmiş altı", "yeddi yüz yetmiş yeddi", "yeddi yüz yetmiş səkkiz", "yeddi yüz yetmiş doqquz", "yeddi yüz səksən", "yeddi yüz səksən bir", "yeddi yüz səksən iki", "yeddi yüz səksən üç", "yeddi yüz səksən dört", "yeddi yüz səksən beş", "yeddi yüz səksən altı", "yeddi yüz səksən yeddi", "yeddi yüz səksən səkkiz", "yeddi yüz səksən doqquz", "yeddi yüz doxsan", "yeddi yüz doxsan bir", "yeddi yüz doxsan iki", "yeddi yüz doxsan üç", "yeddi yüz doxsan dört", "yeddi yüz doxsan beş", "yeddi yüz doxsan altı", "yeddi yüz doxsan yeddi", "yeddi yüz doxsan səkkiz", "yeddi yüz doxsan doqquz", "səkkiz yüz", "səkkiz yüz bir", "səkkiz yüz iki", "səkkiz yüz üç", "səkkiz yüz dört", "səkkiz yüz beş", "səkkiz yüz altı", "səkkiz yüz yeddi", "səkkiz yüz səkkiz", "səkkiz yüz doqquz", "səkkiz yüz on", "səkkiz yüz on bir", "səkkiz yüz on iki", "səkkiz yüz on üç", "səkkiz yüz on dört", "səkkiz yüz on beş", "səkkiz yüz on altı", "səkkiz yüz on yeddi", "səkkiz yüz on səkkiz", "səkkiz yüz on doqquz", "səkkiz yüz yirmi", "səkkiz yüz yirmi bir", "səkkiz yüz yirmi iki", "səkkiz yüz yirmi üç", "səkkiz yüz yirmi dört", "səkkiz yüz yirmi beş", "səkkiz yüz yirmi altı", "səkkiz yüz yirmi yeddi", "səkkiz yüz yirmi səkkiz", "səkkiz yüz yirmi doqquz", "səkkiz yüz otuz", "səkkiz yüz otuz bir", "səkkiz yüz otuz iki", "səkkiz yüz otuz üç", "səkkiz yüz otuz dört", "səkkiz yüz otuz beş", "səkkiz yüz otuz altı", "səkkiz yüz otuz yeddi", "səkkiz yüz otuz səkkiz", "səkkiz yüz otuz doqquz", "səkkiz yüz qırx", "səkkiz yüz qırx bir", "səkkiz yüz qırx iki", "səkkiz yüz qırx üç", "səkkiz yüz qırx dört", "səkkiz yüz qırx beş", "səkkiz yüz qırx altı", "səkkiz yüz qırx yeddi", "səkkiz yüz qırx səkkiz", "səkkiz yüz qırx doqquz", "səkkiz yüz əlli", "səkkiz yüz əlli bir", "səkkiz yüz əlli iki", "səkkiz yüz əlli üç", "səkkiz yüz əlli dört", "səkkiz yüz əlli beş", "səkkiz yüz əlli altı", "səkkiz yüz əlli yeddi", "səkkiz yüz əlli səkkiz", "səkkiz yüz əlli doqquz", "səkkiz yüz altmış", "səkkiz yüz altmış bir", "səkkiz yüz altmış iki", "səkkiz yüz altmış üç", "səkkiz yüz altmış dört", "səkkiz yüz altmış beş", "səkkiz yüz altmış altı", "səkkiz yüz altmış yeddi", "səkkiz yüz altmış səkkiz", "səkkiz yüz altmış doqquz", "səkkiz yüz yetmiş", "səkkiz yüz yetmiş bir", "səkkiz yüz yetmiş iki", "səkkiz yüz yetmiş üç", "səkkiz yüz yetmiş dört", "səkkiz yüz yetmiş beş", "səkkiz yüz yetmiş altı", "səkkiz yüz yetmiş yeddi", "səkkiz yüz yetmiş səkkiz", "səkkiz yüz yetmiş doqquz", "səkkiz yüz səksən", "səkkiz yüz səksən bir", "səkkiz yüz səksən iki", "səkkiz yüz səksən üç", "səkkiz yüz səksən dört", "səkkiz yüz səksən beş", "səkkiz yüz səksən altı", "səkkiz yüz səksən yeddi", "səkkiz yüz səksən səkkiz", "səkkiz yüz səksən doqquz", "səkkiz yüz doxsan", "səkkiz yüz doxsan bir", "səkkiz yüz doxsan iki", "səkkiz yüz doxsan üç", "səkkiz yüz doxsan dört", "səkkiz yüz doxsan beş", "səkkiz yüz doxsan altı", "səkkiz yüz doxsan yeddi", "səkkiz yüz doxsan səkkiz", "səkkiz yüz doxsan doqquz", "doqquz yüz", "doqquz yüz bir", "doqquz yüz iki", "doqquz yüz üç", "doqquz yüz dört", "doqquz yüz beş", "doqquz yüz altı", "doqquz yüz yeddi", "doqquz yüz səkkiz", "doqquz yüz doqquz", "doqquz yüz on", "doqquz yüz on bir", "doqquz yüz on iki", "doqquz yüz on üç", "doqquz yüz on dört", "doqquz yüz on beş", "doqquz yüz on altı", "doqquz yüz on yeddi", "doqquz yüz on səkkiz", "doqquz yüz on doqquz", "doqquz yüz yirmi", "doqquz yüz yirmi bir", "doqquz yüz yirmi iki", "doqquz yüz yirmi üç", "doqquz yüz yirmi dört", "doqquz yüz yirmi beş", "doqquz yüz yirmi altı", "doqquz yüz yirmi yeddi", "doqquz yüz yirmi səkkiz", "doqquz yüz yirmi doqquz", "doqquz yüz otuz", "doqquz yüz otuz bir", "doqquz yüz otuz iki", "doqquz yüz otuz üç", "doqquz yüz otuz dört", "doqquz yüz otuz beş", "doqquz yüz otuz altı", "doqquz yüz otuz yeddi", "doqquz yüz otuz səkkiz", "doqquz yüz otuz doqquz", "doqquz yüz qırx", "doqquz yüz qırx bir", "doqquz yüz qırx iki", "doqquz yüz qırx üç", "doqquz yüz qırx dört", "doqquz yüz qırx beş", "doqquz yüz qırx altı", "doqquz yüz qırx yeddi", "doqquz yüz qırx səkkiz", "doqquz yüz qırx doqquz", "doqquz yüz əlli", "doqquz yüz əlli bir", "doqquz yüz əlli iki", "doqquz yüz əlli üç", "doqquz yüz əlli dört", "doqquz yüz əlli beş", "doqquz yüz əlli altı", "doqquz yüz əlli yeddi", "doqquz yüz əlli səkkiz", "doqquz yüz əlli doqquz", "doqquz yüz altmış", "doqquz yüz altmış bir", "doqquz yüz altmış iki", "doqquz yüz altmış üç", "doqquz yüz altmış dört", "doqquz yüz altmış beş", "doqquz yüz altmış altı", "doqquz yüz altmış yeddi", "doqquz yüz altmış səkkiz", "doqquz yüz altmış doqquz", "doqquz yüz yetmiş", "doqquz yüz yetmiş bir", "doqquz yüz yetmiş iki", "doqquz yüz yetmiş üç", "doqquz yüz yetmiş dört", "doqquz yüz yetmiş beş", "doqquz yüz yetmiş altı", "doqquz yüz yetmiş yeddi", "doqquz yüz yetmiş səkkiz", "doqquz yüz yetmiş doqquz", "doqquz yüz səksən", "doqquz yüz səksən bir", "doqquz yüz səksən iki", "doqquz yüz səksən üç", "doqquz yüz səksən dört", "doqquz yüz səksən beş", "doqquz yüz səksən altı", "doqquz yüz səksən yeddi", "doqquz yüz səksən səkkiz", "doqquz yüz səksən doqquz", "doqquz yüz doxsan", "doqquz yüz doxsan bir", "doqquz yüz doxsan iki", "doqquz yüz doxsan üç", "doqquz yüz doxsan dört", "doqquz yüz doxsan beş", "doqquz yüz doxsan altı", "doqquz yüz doxsan yeddi", "doqquz yüz doxsan səkkiz", "doqquz yüz doxsan doqquz"].freeze
  end
end
