module Humanize
  class Id
    INFINITY = 'tak terhingga'.freeze
    UNDEFINED = 'tak terdefinisi'.freeze
    POINT = 'koma'.freeze
    NEGATIVE = 'minus'.freeze
    LOTS = [nil, 'ribu', 'juta', 'miliar', 'triliun', 'kuadriliun'].freeze
    SUB_ONE_GROUPING = ['nol', 'satu', 'dua', 'tiga', 'empat', 'lima', 'enam', 'tujuh', 'delapan', 'sembilan', 'sepuluh', 'sebelas', 'dua belas', 'tiga belas', 'empat belas', 'lima belas', 'enam belas', 'tujuh belas', 'delapan belas', 'sembilan belas', 'dua puluh', 'dua puluh satu', 'dua puluh dua', 'dua puluh tiga', 'dua puluh empat', 'dua puluh lima', 'dua puluh enam', 'dua puluh tujuh', 'dua puluh delapan', 'dua puluh sembilan', 'tiga puluh', 'tiga puluh satu', 'tiga puluh dua', 'tiga puluh tiga', 'tiga puluh empat', 'tiga puluh lima', 'tiga puluh enam', 'tiga puluh tujuh', 'tiga puluh delapan', 'tiga puluh sembilan', 'empat puluh', 'empat puluh satu', 'empat puluh dua', 'empat puluh tiga', 'empat puluh empat', 'empat puluh lima', 'empat puluh enam', 'empat puluh tujuh', 'empat puluh delapan', 'empat puluh sembilan', 'lima puluh', 'lima puluh satu', 'lima puluh dua', 'lima puluh tiga', 'lima puluh empat', 'lima puluh lima', 'lima puluh enam', 'lima puluh tujuh', 'lima puluh delapan', 'lima puluh sembilan', 'enam puluh', 'enam puluh satu', 'enam puluh dua', 'enam puluh tiga', 'enam puluh empat', 'enam puluh lima', 'enam puluh enam', 'enam puluh tujuh', 'enam puluh delapan', 'enam puluh sembilan', 'tujuh puluh', 'tujuh puluh satu', 'tujuh puluh dua', 'tujuh puluh tiga', 'tujuh puluh empat', 'tujuh puluh lima', 'tujuh puluh enam', 'tujuh puluh tujuh', 'tujuh puluh delapan', 'tujuh puluh sembilan', 'delapan puluh', 'delapan puluh satu', 'delapan puluh dua', 'delapan puluh tiga', 'delapan puluh empat', 'delapan puluh lima', 'delapan puluh enam', 'delapan puluh tujuh', 'delapan puluh delapan', 'delapan puluh sembilan', 'sembilan puluh', 'sembilan puluh satu', 'sembilan puluh dua', 'sembilan puluh tiga', 'sembilan puluh empat', 'sembilan puluh lima', 'sembilan puluh enam', 'sembilan puluh tujuh', 'sembilan puluh delapan', 'sembilan puluh sembilan', 'seratus', 'seratus satu', 'seratus dua', 'seratus tiga', 'seratus empat', 'seratus lima', 'seratus enam', 'seratus tujuh', 'seratus delapan', 'seratus sembilan', 'seratus sepuluh', 'seratus sebelas', 'seratus dua belas', 'seratus tiga belas', 'seratus empat belas', 'seratus lima belas', 'seratus enam belas', 'seratus tujuh belas', 'seratus delapan belas', 'seratus sembilan belas', 'seratus dua puluh', 'seratus dua puluh satu', 'seratus dua puluh dua', 'seratus dua puluh tiga', 'seratus dua puluh empat', 'seratus dua puluh lima', 'seratus dua puluh enam', 'seratus dua puluh tujuh', 'seratus dua puluh delapan', 'seratus dua puluh sembilan', 'seratus tiga puluh', 'seratus tiga puluh satu', 'seratus tiga puluh dua', 'seratus tiga puluh tiga', 'seratus tiga puluh empat', 'seratus tiga puluh lima', 'seratus tiga puluh enam', 'seratus tiga puluh tujuh', 'seratus tiga puluh delapan', 'seratus tiga puluh sembilan', 'seratus empat puluh', 'seratus empat puluh satu', 'seratus empat puluh dua', 'seratus empat puluh tiga', 'seratus empat puluh empat', 'seratus empat puluh lima', 'seratus empat puluh enam', 'seratus empat puluh tujuh', 'seratus empat puluh delapan', 'seratus empat puluh sembilan', 'seratus lima puluh', 'seratus lima puluh satu', 'seratus lima puluh dua', 'seratus lima puluh tiga', 'seratus lima puluh empat', 'seratus lima puluh lima', 'seratus lima puluh enam', 'seratus lima puluh tujuh', 'seratus lima puluh delapan', 'seratus lima puluh sembilan', 'seratus enam puluh', 'seratus enam puluh satu', 'seratus enam puluh dua', 'seratus enam puluh tiga', 'seratus enam puluh empat', 'seratus enam puluh lima', 'seratus enam puluh enam', 'seratus enam puluh tujuh', 'seratus enam puluh delapan', 'seratus enam puluh sembilan', 'seratus tujuh puluh', 'seratus tujuh puluh satu', 'seratus tujuh puluh dua', 'seratus tujuh puluh tiga', 'seratus tujuh puluh empat', 'seratus tujuh puluh lima', 'seratus tujuh puluh enam', 'seratus tujuh puluh tujuh', 'seratus tujuh puluh delapan', 'seratus tujuh puluh sembilan', 'seratus delapan puluh', 'seratus delapan puluh satu', 'seratus delapan puluh dua', 'seratus delapan puluh tiga', 'seratus delapan puluh empat', 'seratus delapan puluh lima', 'seratus delapan puluh enam', 'seratus delapan puluh tujuh', 'seratus delapan puluh delapan', 'seratus delapan puluh sembilan', 'seratus sembilan puluh', 'seratus sembilan puluh satu', 'seratus sembilan puluh dua', 'seratus sembilan puluh tiga', 'seratus sembilan puluh empat', 'seratus sembilan puluh lima', 'seratus sembilan puluh enam', 'seratus sembilan puluh tujuh', 'seratus sembilan puluh delapan', 'seratus sembilan puluh sembilan', 'dua ratus', 'dua ratus satu', 'dua ratus dua', 'dua ratus tiga', 'dua ratus empat', 'dua ratus lima', 'dua ratus enam', 'dua ratus tujuh', 'dua ratus delapan', 'dua ratus sembilan', 'dua ratus sepuluh', 'dua ratus sebelas', 'dua ratus dua belas', 'dua ratus tiga belas', 'dua ratus empat belas', 'dua ratus lima belas', 'dua ratus enam belas', 'dua ratus tujuh belas', 'dua ratus delapan belas', 'dua ratus sembilan belas', 'dua ratus dua puluh', 'dua ratus dua puluh satu', 'dua ratus dua puluh dua', 'dua ratus dua puluh tiga', 'dua ratus dua puluh empat', 'dua ratus dua puluh lima', 'dua ratus dua puluh enam', 'dua ratus dua puluh tujuh', 'dua ratus dua puluh delapan', 'dua ratus dua puluh sembilan', 'dua ratus tiga puluh', 'dua ratus tiga puluh satu', 'dua ratus tiga puluh dua', 'dua ratus tiga puluh tiga', 'dua ratus tiga puluh empat', 'dua ratus tiga puluh lima', 'dua ratus tiga puluh enam', 'dua ratus tiga puluh tujuh', 'dua ratus tiga puluh delapan', 'dua ratus tiga puluh sembilan', 'dua ratus empat puluh', 'dua ratus empat puluh satu', 'dua ratus empat puluh dua', 'dua ratus empat puluh tiga', 'dua ratus empat puluh empat', 'dua ratus empat puluh lima', 'dua ratus empat puluh enam', 'dua ratus empat puluh tujuh', 'dua ratus empat puluh delapan', 'dua ratus empat puluh sembilan', 'dua ratus lima puluh', 'dua ratus lima puluh satu', 'dua ratus lima puluh dua', 'dua ratus lima puluh tiga', 'dua ratus lima puluh empat', 'dua ratus lima puluh lima', 'dua ratus lima puluh enam', 'dua ratus lima puluh tujuh', 'dua ratus lima puluh delapan', 'dua ratus lima puluh sembilan', 'dua ratus enam puluh', 'dua ratus enam puluh satu', 'dua ratus enam puluh dua', 'dua ratus enam puluh tiga', 'dua ratus enam puluh empat', 'dua ratus enam puluh lima', 'dua ratus enam puluh enam', 'dua ratus enam puluh tujuh', 'dua ratus enam puluh delapan', 'dua ratus enam puluh sembilan', 'dua ratus tujuh puluh', 'dua ratus tujuh puluh satu', 'dua ratus tujuh puluh dua', 'dua ratus tujuh puluh tiga', 'dua ratus tujuh puluh empat', 'dua ratus tujuh puluh lima', 'dua ratus tujuh puluh enam', 'dua ratus tujuh puluh tujuh', 'dua ratus tujuh puluh delapan', 'dua ratus tujuh puluh sembilan', 'dua ratus delapan puluh', 'dua ratus delapan puluh satu', 'dua ratus delapan puluh dua', 'dua ratus delapan puluh tiga', 'dua ratus delapan puluh empat', 'dua ratus delapan puluh lima', 'dua ratus delapan puluh enam', 'dua ratus delapan puluh tujuh', 'dua ratus delapan puluh delapan', 'dua ratus delapan puluh sembilan', 'dua ratus sembilan puluh', 'dua ratus sembilan puluh satu', 'dua ratus sembilan puluh dua', 'dua ratus sembilan puluh tiga', 'dua ratus sembilan puluh empat', 'dua ratus sembilan puluh lima', 'dua ratus sembilan puluh enam', 'dua ratus sembilan puluh tujuh', 'dua ratus sembilan puluh delapan', 'dua ratus sembilan puluh sembilan', 'tiga ratus', 'tiga ratus satu', 'tiga ratus dua', 'tiga ratus tiga', 'tiga ratus empat', 'tiga ratus lima', 'tiga ratus enam', 'tiga ratus tujuh', 'tiga ratus delapan', 'tiga ratus sembilan', 'tiga ratus sepuluh', 'tiga ratus sebelas', 'tiga ratus dua belas', 'tiga ratus tiga belas', 'tiga ratus empat belas', 'tiga ratus lima belas', 'tiga ratus enam belas', 'tiga ratus tujuh belas', 'tiga ratus delapan belas', 'tiga ratus sembilan belas', 'tiga ratus dua puluh', 'tiga ratus dua puluh satu', 'tiga ratus dua puluh dua', 'tiga ratus dua puluh tiga', 'tiga ratus dua puluh empat', 'tiga ratus dua puluh lima', 'tiga ratus dua puluh enam', 'tiga ratus dua puluh tujuh', 'tiga ratus dua puluh delapan', 'tiga ratus dua puluh sembilan', 'tiga ratus tiga puluh', 'tiga ratus tiga puluh satu', 'tiga ratus tiga puluh dua', 'tiga ratus tiga puluh tiga', 'tiga ratus tiga puluh empat', 'tiga ratus tiga puluh lima', 'tiga ratus tiga puluh enam', 'tiga ratus tiga puluh tujuh', 'tiga ratus tiga puluh delapan', 'tiga ratus tiga puluh sembilan', 'tiga ratus empat puluh', 'tiga ratus empat puluh satu', 'tiga ratus empat puluh dua', 'tiga ratus empat puluh tiga', 'tiga ratus empat puluh empat', 'tiga ratus empat puluh lima', 'tiga ratus empat puluh enam', 'tiga ratus empat puluh tujuh', 'tiga ratus empat puluh delapan', 'tiga ratus empat puluh sembilan', 'tiga ratus lima puluh', 'tiga ratus lima puluh satu', 'tiga ratus lima puluh dua', 'tiga ratus lima puluh tiga', 'tiga ratus lima puluh empat', 'tiga ratus lima puluh lima', 'tiga ratus lima puluh enam', 'tiga ratus lima puluh tujuh', 'tiga ratus lima puluh delapan', 'tiga ratus lima puluh sembilan', 'tiga ratus enam puluh', 'tiga ratus enam puluh satu', 'tiga ratus enam puluh dua', 'tiga ratus enam puluh tiga', 'tiga ratus enam puluh empat', 'tiga ratus enam puluh lima', 'tiga ratus enam puluh enam', 'tiga ratus enam puluh tujuh', 'tiga ratus enam puluh delapan', 'tiga ratus enam puluh sembilan', 'tiga ratus tujuh puluh', 'tiga ratus tujuh puluh satu', 'tiga ratus tujuh puluh dua', 'tiga ratus tujuh puluh tiga', 'tiga ratus tujuh puluh empat', 'tiga ratus tujuh puluh lima', 'tiga ratus tujuh puluh enam', 'tiga ratus tujuh puluh tujuh', 'tiga ratus tujuh puluh delapan', 'tiga ratus tujuh puluh sembilan', 'tiga ratus delapan puluh', 'tiga ratus delapan puluh satu', 'tiga ratus delapan puluh dua', 'tiga ratus delapan puluh tiga', 'tiga ratus delapan puluh empat', 'tiga ratus delapan puluh lima', 'tiga ratus delapan puluh enam', 'tiga ratus delapan puluh tujuh', 'tiga ratus delapan puluh delapan', 'tiga ratus delapan puluh sembilan', 'tiga ratus sembilan puluh', 'tiga ratus sembilan puluh satu', 'tiga ratus sembilan puluh dua', 'tiga ratus sembilan puluh tiga', 'tiga ratus sembilan puluh empat', 'tiga ratus sembilan puluh lima', 'tiga ratus sembilan puluh enam', 'tiga ratus sembilan puluh tujuh', 'tiga ratus sembilan puluh delapan', 'tiga ratus sembilan puluh sembilan', 'empat ratus', 'empat ratus satu', 'empat ratus dua', 'empat ratus tiga', 'empat ratus empat', 'empat ratus lima', 'empat ratus enam', 'empat ratus tujuh', 'empat ratus delapan', 'empat ratus sembilan', 'empat ratus sepuluh', 'empat ratus sebelas', 'empat ratus dua belas', 'empat ratus tiga belas', 'empat ratus empat belas', 'empat ratus lima belas', 'empat ratus enam belas', 'empat ratus tujuh belas', 'empat ratus delapan belas', 'empat ratus sembilan belas', 'empat ratus dua puluh', 'empat ratus dua puluh satu', 'empat ratus dua puluh dua', 'empat ratus dua puluh tiga', 'empat ratus dua puluh empat', 'empat ratus dua puluh lima', 'empat ratus dua puluh enam', 'empat ratus dua puluh tujuh', 'empat ratus dua puluh delapan', 'empat ratus dua puluh sembilan', 'empat ratus tiga puluh', 'empat ratus tiga puluh satu', 'empat ratus tiga puluh dua', 'empat ratus tiga puluh tiga', 'empat ratus tiga puluh empat', 'empat ratus tiga puluh lima', 'empat ratus tiga puluh enam', 'empat ratus tiga puluh tujuh', 'empat ratus tiga puluh delapan', 'empat ratus tiga puluh sembilan', 'empat ratus empat puluh', 'empat ratus empat puluh satu', 'empat ratus empat puluh dua', 'empat ratus empat puluh tiga', 'empat ratus empat puluh empat', 'empat ratus empat puluh lima', 'empat ratus empat puluh enam', 'empat ratus empat puluh tujuh', 'empat ratus empat puluh delapan', 'empat ratus empat puluh sembilan', 'empat ratus lima puluh', 'empat ratus lima puluh satu', 'empat ratus lima puluh dua', 'empat ratus lima puluh tiga', 'empat ratus lima puluh empat', 'empat ratus lima puluh lima', 'empat ratus lima puluh enam', 'empat ratus lima puluh tujuh', 'empat ratus lima puluh delapan', 'empat ratus lima puluh sembilan', 'empat ratus enam puluh', 'empat ratus enam puluh satu', 'empat ratus enam puluh dua', 'empat ratus enam puluh tiga', 'empat ratus enam puluh empat', 'empat ratus enam puluh lima', 'empat ratus enam puluh enam', 'empat ratus enam puluh tujuh', 'empat ratus enam puluh delapan', 'empat ratus enam puluh sembilan', 'empat ratus tujuh puluh', 'empat ratus tujuh puluh satu', 'empat ratus tujuh puluh dua', 'empat ratus tujuh puluh tiga', 'empat ratus tujuh puluh empat', 'empat ratus tujuh puluh lima', 'empat ratus tujuh puluh enam', 'empat ratus tujuh puluh tujuh', 'empat ratus tujuh puluh delapan', 'empat ratus tujuh puluh sembilan', 'empat ratus delapan puluh', 'empat ratus delapan puluh satu', 'empat ratus delapan puluh dua', 'empat ratus delapan puluh tiga', 'empat ratus delapan puluh empat', 'empat ratus delapan puluh lima', 'empat ratus delapan puluh enam', 'empat ratus delapan puluh tujuh', 'empat ratus delapan puluh delapan', 'empat ratus delapan puluh sembilan', 'empat ratus sembilan puluh', 'empat ratus sembilan puluh satu', 'empat ratus sembilan puluh dua', 'empat ratus sembilan puluh tiga', 'empat ratus sembilan puluh empat', 'empat ratus sembilan puluh lima', 'empat ratus sembilan puluh enam', 'empat ratus sembilan puluh tujuh', 'empat ratus sembilan puluh delapan', 'empat ratus sembilan puluh sembilan', 'lima ratus', 'lima ratus satu', 'lima ratus dua', 'lima ratus tiga', 'lima ratus empat', 'lima ratus lima', 'lima ratus enam', 'lima ratus tujuh', 'lima ratus delapan', 'lima ratus sembilan', 'lima ratus sepuluh', 'lima ratus sebelas', 'lima ratus dua belas', 'lima ratus tiga belas', 'lima ratus empat belas', 'lima ratus lima belas', 'lima ratus enam belas', 'lima ratus tujuh belas', 'lima ratus delapan belas', 'lima ratus sembilan belas', 'lima ratus dua puluh', 'lima ratus dua puluh satu', 'lima ratus dua puluh dua', 'lima ratus dua puluh tiga', 'lima ratus dua puluh empat', 'lima ratus dua puluh lima', 'lima ratus dua puluh enam', 'lima ratus dua puluh tujuh', 'lima ratus dua puluh delapan', 'lima ratus dua puluh sembilan', 'lima ratus tiga puluh', 'lima ratus tiga puluh satu', 'lima ratus tiga puluh dua', 'lima ratus tiga puluh tiga', 'lima ratus tiga puluh empat', 'lima ratus tiga puluh lima', 'lima ratus tiga puluh enam', 'lima ratus tiga puluh tujuh', 'lima ratus tiga puluh delapan', 'lima ratus tiga puluh sembilan', 'lima ratus empat puluh', 'lima ratus empat puluh satu', 'lima ratus empat puluh dua', 'lima ratus empat puluh tiga', 'lima ratus empat puluh empat', 'lima ratus empat puluh lima', 'lima ratus empat puluh enam', 'lima ratus empat puluh tujuh', 'lima ratus empat puluh delapan', 'lima ratus empat puluh sembilan', 'lima ratus lima puluh', 'lima ratus lima puluh satu', 'lima ratus lima puluh dua', 'lima ratus lima puluh tiga', 'lima ratus lima puluh empat', 'lima ratus lima puluh lima', 'lima ratus lima puluh enam', 'lima ratus lima puluh tujuh', 'lima ratus lima puluh delapan', 'lima ratus lima puluh sembilan', 'lima ratus enam puluh', 'lima ratus enam puluh satu', 'lima ratus enam puluh dua', 'lima ratus enam puluh tiga', 'lima ratus enam puluh empat', 'lima ratus enam puluh lima', 'lima ratus enam puluh enam', 'lima ratus enam puluh tujuh', 'lima ratus enam puluh delapan', 'lima ratus enam puluh sembilan', 'lima ratus tujuh puluh', 'lima ratus tujuh puluh satu', 'lima ratus tujuh puluh dua', 'lima ratus tujuh puluh tiga', 'lima ratus tujuh puluh empat', 'lima ratus tujuh puluh lima', 'lima ratus tujuh puluh enam', 'lima ratus tujuh puluh tujuh', 'lima ratus tujuh puluh delapan', 'lima ratus tujuh puluh sembilan', 'lima ratus delapan puluh', 'lima ratus delapan puluh satu', 'lima ratus delapan puluh dua', 'lima ratus delapan puluh tiga', 'lima ratus delapan puluh empat', 'lima ratus delapan puluh lima', 'lima ratus delapan puluh enam', 'lima ratus delapan puluh tujuh', 'lima ratus delapan puluh delapan', 'lima ratus delapan puluh sembilan', 'lima ratus sembilan puluh', 'lima ratus sembilan puluh satu', 'lima ratus sembilan puluh dua', 'lima ratus sembilan puluh tiga', 'lima ratus sembilan puluh empat', 'lima ratus sembilan puluh lima', 'lima ratus sembilan puluh enam', 'lima ratus sembilan puluh tujuh', 'lima ratus sembilan puluh delapan', 'lima ratus sembilan puluh sembilan', 'enam ratus', 'enam ratus satu', 'enam ratus dua', 'enam ratus tiga', 'enam ratus empat', 'enam ratus lima', 'enam ratus enam', 'enam ratus tujuh', 'enam ratus delapan', 'enam ratus sembilan', 'enam ratus sepuluh', 'enam ratus sebelas', 'enam ratus dua belas', 'enam ratus tiga belas', 'enam ratus empat belas', 'enam ratus lima belas', 'enam ratus enam belas', 'enam ratus tujuh belas', 'enam ratus delapan belas', 'enam ratus sembilan belas', 'enam ratus dua puluh', 'enam ratus dua puluh satu', 'enam ratus dua puluh dua', 'enam ratus dua puluh tiga', 'enam ratus dua puluh empat', 'enam ratus dua puluh lima', 'enam ratus dua puluh enam', 'enam ratus dua puluh tujuh', 'enam ratus dua puluh delapan', 'enam ratus dua puluh sembilan', 'enam ratus tiga puluh', 'enam ratus tiga puluh satu', 'enam ratus tiga puluh dua', 'enam ratus tiga puluh tiga', 'enam ratus tiga puluh empat', 'enam ratus tiga puluh lima', 'enam ratus tiga puluh enam', 'enam ratus tiga puluh tujuh', 'enam ratus tiga puluh delapan', 'enam ratus tiga puluh sembilan', 'enam ratus empat puluh', 'enam ratus empat puluh satu', 'enam ratus empat puluh dua', 'enam ratus empat puluh tiga', 'enam ratus empat puluh empat', 'enam ratus empat puluh lima', 'enam ratus empat puluh enam', 'enam ratus empat puluh tujuh', 'enam ratus empat puluh delapan', 'enam ratus empat puluh sembilan', 'enam ratus lima puluh', 'enam ratus lima puluh satu', 'enam ratus lima puluh dua', 'enam ratus lima puluh tiga', 'enam ratus lima puluh empat', 'enam ratus lima puluh lima', 'enam ratus lima puluh enam', 'enam ratus lima puluh tujuh', 'enam ratus lima puluh delapan', 'enam ratus lima puluh sembilan', 'enam ratus enam puluh', 'enam ratus enam puluh satu', 'enam ratus enam puluh dua', 'enam ratus enam puluh tiga', 'enam ratus enam puluh empat', 'enam ratus enam puluh lima', 'enam ratus enam puluh enam', 'enam ratus enam puluh tujuh', 'enam ratus enam puluh delapan', 'enam ratus enam puluh sembilan', 'enam ratus tujuh puluh', 'enam ratus tujuh puluh satu', 'enam ratus tujuh puluh dua', 'enam ratus tujuh puluh tiga', 'enam ratus tujuh puluh empat', 'enam ratus tujuh puluh lima', 'enam ratus tujuh puluh enam', 'enam ratus tujuh puluh tujuh', 'enam ratus tujuh puluh delapan', 'enam ratus tujuh puluh sembilan', 'enam ratus delapan puluh', 'enam ratus delapan puluh satu', 'enam ratus delapan puluh dua', 'enam ratus delapan puluh tiga', 'enam ratus delapan puluh empat', 'enam ratus delapan puluh lima', 'enam ratus delapan puluh enam', 'enam ratus delapan puluh tujuh', 'enam ratus delapan puluh delapan', 'enam ratus delapan puluh sembilan', 'enam ratus sembilan puluh', 'enam ratus sembilan puluh satu', 'enam ratus sembilan puluh dua', 'enam ratus sembilan puluh tiga', 'enam ratus sembilan puluh empat', 'enam ratus sembilan puluh lima', 'enam ratus sembilan puluh enam', 'enam ratus sembilan puluh tujuh', 'enam ratus sembilan puluh delapan', 'enam ratus sembilan puluh sembilan', 'tujuh ratus', 'tujuh ratus satu', 'tujuh ratus dua', 'tujuh ratus tiga', 'tujuh ratus empat', 'tujuh ratus lima', 'tujuh ratus enam', 'tujuh ratus tujuh', 'tujuh ratus delapan', 'tujuh ratus sembilan', 'tujuh ratus sepuluh', 'tujuh ratus sebelas', 'tujuh ratus dua belas', 'tujuh ratus tiga belas', 'tujuh ratus empat belas', 'tujuh ratus lima belas', 'tujuh ratus enam belas', 'tujuh ratus tujuh belas', 'tujuh ratus delapan belas', 'tujuh ratus sembilan belas', 'tujuh ratus dua puluh', 'tujuh ratus dua puluh satu', 'tujuh ratus dua puluh dua', 'tujuh ratus dua puluh tiga', 'tujuh ratus dua puluh empat', 'tujuh ratus dua puluh lima', 'tujuh ratus dua puluh enam', 'tujuh ratus dua puluh tujuh', 'tujuh ratus dua puluh delapan', 'tujuh ratus dua puluh sembilan', 'tujuh ratus tiga puluh', 'tujuh ratus tiga puluh satu', 'tujuh ratus tiga puluh dua', 'tujuh ratus tiga puluh tiga', 'tujuh ratus tiga puluh empat', 'tujuh ratus tiga puluh lima', 'tujuh ratus tiga puluh enam', 'tujuh ratus tiga puluh tujuh', 'tujuh ratus tiga puluh delapan', 'tujuh ratus tiga puluh sembilan', 'tujuh ratus empat puluh', 'tujuh ratus empat puluh satu', 'tujuh ratus empat puluh dua', 'tujuh ratus empat puluh tiga', 'tujuh ratus empat puluh empat', 'tujuh ratus empat puluh lima', 'tujuh ratus empat puluh enam', 'tujuh ratus empat puluh tujuh', 'tujuh ratus empat puluh delapan', 'tujuh ratus empat puluh sembilan', 'tujuh ratus lima puluh', 'tujuh ratus lima puluh satu', 'tujuh ratus lima puluh dua', 'tujuh ratus lima puluh tiga', 'tujuh ratus lima puluh empat', 'tujuh ratus lima puluh lima', 'tujuh ratus lima puluh enam', 'tujuh ratus lima puluh tujuh', 'tujuh ratus lima puluh delapan', 'tujuh ratus lima puluh sembilan', 'tujuh ratus enam puluh', 'tujuh ratus enam puluh satu', 'tujuh ratus enam puluh dua', 'tujuh ratus enam puluh tiga', 'tujuh ratus enam puluh empat', 'tujuh ratus enam puluh lima', 'tujuh ratus enam puluh enam', 'tujuh ratus enam puluh tujuh', 'tujuh ratus enam puluh delapan', 'tujuh ratus enam puluh sembilan', 'tujuh ratus tujuh puluh', 'tujuh ratus tujuh puluh satu', 'tujuh ratus tujuh puluh dua', 'tujuh ratus tujuh puluh tiga', 'tujuh ratus tujuh puluh empat', 'tujuh ratus tujuh puluh lima', 'tujuh ratus tujuh puluh enam', 'tujuh ratus tujuh puluh tujuh', 'tujuh ratus tujuh puluh delapan', 'tujuh ratus tujuh puluh sembilan', 'tujuh ratus delapan puluh', 'tujuh ratus delapan puluh satu', 'tujuh ratus delapan puluh dua', 'tujuh ratus delapan puluh tiga', 'tujuh ratus delapan puluh empat', 'tujuh ratus delapan puluh lima', 'tujuh ratus delapan puluh enam', 'tujuh ratus delapan puluh tujuh', 'tujuh ratus delapan puluh delapan', 'tujuh ratus delapan puluh sembilan', 'tujuh ratus sembilan puluh', 'tujuh ratus sembilan puluh satu', 'tujuh ratus sembilan puluh dua', 'tujuh ratus sembilan puluh tiga', 'tujuh ratus sembilan puluh empat', 'tujuh ratus sembilan puluh lima', 'tujuh ratus sembilan puluh enam', 'tujuh ratus sembilan puluh tujuh', 'tujuh ratus sembilan puluh delapan', 'tujuh ratus sembilan puluh sembilan', 'delapan ratus', 'delapan ratus satu', 'delapan ratus dua', 'delapan ratus tiga', 'delapan ratus empat', 'delapan ratus lima', 'delapan ratus enam', 'delapan ratus tujuh', 'delapan ratus delapan', 'delapan ratus sembilan', 'delapan ratus sepuluh', 'delapan ratus sebelas', 'delapan ratus dua belas', 'delapan ratus tiga belas', 'delapan ratus empat belas', 'delapan ratus lima belas', 'delapan ratus enam belas', 'delapan ratus tujuh belas', 'delapan ratus delapan belas', 'delapan ratus sembilan belas', 'delapan ratus dua puluh', 'delapan ratus dua puluh satu', 'delapan ratus dua puluh dua', 'delapan ratus dua puluh tiga', 'delapan ratus dua puluh empat', 'delapan ratus dua puluh lima', 'delapan ratus dua puluh enam', 'delapan ratus dua puluh tujuh', 'delapan ratus dua puluh delapan', 'delapan ratus dua puluh sembilan', 'delapan ratus tiga puluh', 'delapan ratus tiga puluh satu', 'delapan ratus tiga puluh dua', 'delapan ratus tiga puluh tiga', 'delapan ratus tiga puluh empat', 'delapan ratus tiga puluh lima', 'delapan ratus tiga puluh enam', 'delapan ratus tiga puluh tujuh', 'delapan ratus tiga puluh delapan', 'delapan ratus tiga puluh sembilan', 'delapan ratus empat puluh', 'delapan ratus empat puluh satu', 'delapan ratus empat puluh dua', 'delapan ratus empat puluh tiga', 'delapan ratus empat puluh empat', 'delapan ratus empat puluh lima', 'delapan ratus empat puluh enam', 'delapan ratus empat puluh tujuh', 'delapan ratus empat puluh delapan', 'delapan ratus empat puluh sembilan', 'delapan ratus lima puluh', 'delapan ratus lima puluh satu', 'delapan ratus lima puluh dua', 'delapan ratus lima puluh tiga', 'delapan ratus lima puluh empat', 'delapan ratus lima puluh lima', 'delapan ratus lima puluh enam', 'delapan ratus lima puluh tujuh', 'delapan ratus lima puluh delapan', 'delapan ratus lima puluh sembilan', 'delapan ratus enam puluh', 'delapan ratus enam puluh satu', 'delapan ratus enam puluh dua', 'delapan ratus enam puluh tiga', 'delapan ratus enam puluh empat', 'delapan ratus enam puluh lima', 'delapan ratus enam puluh enam', 'delapan ratus enam puluh tujuh', 'delapan ratus enam puluh delapan', 'delapan ratus enam puluh sembilan', 'delapan ratus tujuh puluh', 'delapan ratus tujuh puluh satu', 'delapan ratus tujuh puluh dua', 'delapan ratus tujuh puluh tiga', 'delapan ratus tujuh puluh empat', 'delapan ratus tujuh puluh lima', 'delapan ratus tujuh puluh enam', 'delapan ratus tujuh puluh tujuh', 'delapan ratus tujuh puluh delapan', 'delapan ratus tujuh puluh sembilan', 'delapan ratus delapan puluh', 'delapan ratus delapan puluh satu', 'delapan ratus delapan puluh dua', 'delapan ratus delapan puluh tiga', 'delapan ratus delapan puluh empat', 'delapan ratus delapan puluh lima', 'delapan ratus delapan puluh enam', 'delapan ratus delapan puluh tujuh', 'delapan ratus delapan puluh delapan', 'delapan ratus delapan puluh sembilan', 'delapan ratus sembilan puluh', 'delapan ratus sembilan puluh satu', 'delapan ratus sembilan puluh dua', 'delapan ratus sembilan puluh tiga', 'delapan ratus sembilan puluh empat', 'delapan ratus sembilan puluh lima', 'delapan ratus sembilan puluh enam', 'delapan ratus sembilan puluh tujuh', 'delapan ratus sembilan puluh delapan', 'delapan ratus sembilan puluh sembilan', 'sembilan ratus', 'sembilan ratus satu', 'sembilan ratus dua', 'sembilan ratus tiga', 'sembilan ratus empat', 'sembilan ratus lima', 'sembilan ratus enam', 'sembilan ratus tujuh', 'sembilan ratus delapan', 'sembilan ratus sembilan', 'sembilan ratus sepuluh', 'sembilan ratus sebelas', 'sembilan ratus dua belas', 'sembilan ratus tiga belas', 'sembilan ratus empat belas', 'sembilan ratus lima belas', 'sembilan ratus enam belas', 'sembilan ratus tujuh belas', 'sembilan ratus delapan belas', 'sembilan ratus sembilan belas', 'sembilan ratus dua puluh', 'sembilan ratus dua puluh satu', 'sembilan ratus dua puluh dua', 'sembilan ratus dua puluh tiga', 'sembilan ratus dua puluh empat', 'sembilan ratus dua puluh lima', 'sembilan ratus dua puluh enam', 'sembilan ratus dua puluh tujuh', 'sembilan ratus dua puluh delapan', 'sembilan ratus dua puluh sembilan', 'sembilan ratus tiga puluh', 'sembilan ratus tiga puluh satu', 'sembilan ratus tiga puluh dua', 'sembilan ratus tiga puluh tiga', 'sembilan ratus tiga puluh empat', 'sembilan ratus tiga puluh lima', 'sembilan ratus tiga puluh enam', 'sembilan ratus tiga puluh tujuh', 'sembilan ratus tiga puluh delapan', 'sembilan ratus tiga puluh sembilan', 'sembilan ratus empat puluh', 'sembilan ratus empat puluh satu', 'sembilan ratus empat puluh dua', 'sembilan ratus empat puluh tiga', 'sembilan ratus empat puluh empat', 'sembilan ratus empat puluh lima', 'sembilan ratus empat puluh enam', 'sembilan ratus empat puluh tujuh', 'sembilan ratus empat puluh delapan', 'sembilan ratus empat puluh sembilan', 'sembilan ratus lima puluh', 'sembilan ratus lima puluh satu', 'sembilan ratus lima puluh dua', 'sembilan ratus lima puluh tiga', 'sembilan ratus lima puluh empat', 'sembilan ratus lima puluh lima', 'sembilan ratus lima puluh enam', 'sembilan ratus lima puluh tujuh', 'sembilan ratus lima puluh delapan', 'sembilan ratus lima puluh sembilan', 'sembilan ratus enam puluh', 'sembilan ratus enam puluh satu', 'sembilan ratus enam puluh dua', 'sembilan ratus enam puluh tiga', 'sembilan ratus enam puluh empat', 'sembilan ratus enam puluh lima', 'sembilan ratus enam puluh enam', 'sembilan ratus enam puluh tujuh', 'sembilan ratus enam puluh delapan', 'sembilan ratus enam puluh sembilan', 'sembilan ratus tujuh puluh', 'sembilan ratus tujuh puluh satu', 'sembilan ratus tujuh puluh dua', 'sembilan ratus tujuh puluh tiga', 'sembilan ratus tujuh puluh empat', 'sembilan ratus tujuh puluh lima', 'sembilan ratus tujuh puluh enam', 'sembilan ratus tujuh puluh tujuh', 'sembilan ratus tujuh puluh delapan', 'sembilan ratus tujuh puluh sembilan', 'sembilan ratus delapan puluh', 'sembilan ratus delapan puluh satu', 'sembilan ratus delapan puluh dua', 'sembilan ratus delapan puluh tiga', 'sembilan ratus delapan puluh empat', 'sembilan ratus delapan puluh lima', 'sembilan ratus delapan puluh enam', 'sembilan ratus delapan puluh tujuh', 'sembilan ratus delapan puluh delapan', 'sembilan ratus delapan puluh sembilan', 'sembilan ratus sembilan puluh', 'sembilan ratus sembilan puluh satu', 'sembilan ratus sembilan puluh dua', 'sembilan ratus sembilan puluh tiga', 'sembilan ratus sembilan puluh empat', 'sembilan ratus sembilan puluh lima', 'sembilan ratus sembilan puluh enam', 'sembilan ratus sembilan puluh tujuh', 'sembilan ratus sembilan puluh delapan', 'sembilan ratus sembilan puluh sembilan'].freeze
  end
end
