module Humanize
  class Pt
    INFINITY = 'infinito'.freeze
    UNDEFINED = 'indefinido'.freeze
    NEGATIVE = 'negativo'.freeze
    POINT = 'vírgula'.freeze
    LOTS = [nil, 'mil', 'milhão', 'bilhão', 'trilhão', 'quatrilhão', 'quintilhão', 'sextilhão', 'septilhão', 'octilhão', 'nonilhão', 'decilhão', 'undecilhão', 'duodecilhão', 'tredecilhão', 'quattuordecilhão', 'quindecilhão', 'sexdecilhão', 'septendecilhão', 'octodecilhão', 'novemdecilhão', 'vigintilhão', 'unvigintilhão', 'duovigintilhão', 'trevigintilhão', 'quattuortilhão', 'quinvigintilhão', 'sexvigintilhão', 'septenvigintilhão', 'octovigintilhão', 'novemvigintilhão', 'trigintilhão', 'untrigintilhão', 'duotrigintilhão', 'trêstrigintilhão', 'quattuortrigintilhão', 'quintrigintilhão', 'sextrigintilhão', 'septentrigintilhão', 'octotrigintilhão', 'novemtrigintilhão', 'quadragintilhão', 'unquadragintilhão', 'duoquadragintilhão', 'trequadragintilhão', 'quattuorquadragintilhão', 'quinquadragintilhão', 'sesquadragintilhão', 'septenquadragintilhão', 'octoquadragintilhão', 'novenquadragintilhão', 'quinquagintilhão'].freeze
    SUB_ONE_GROUPING = ['zero', 'um', 'dois', 'três', 'quatro', 'cinco', 'seis', 'sete', 'oito', 'nove', 'dez', 'onze', 'doze', 'treze', 'quatorze', 'quinze', 'dezesseis', 'dezessete', 'dezoito', 'dezenove', 'vinte', 'vinte e um', 'vinte e dois', 'vinte e três', 'vinte e quatro', 'vinte e cinco', 'vinte e seis', 'vinte e sete', 'vinte e oito', 'vinte e nove', 'trinta', 'trinta e um', 'trinta e dois', 'trinta e três', 'trinta e quatro', 'trinta e cinco', 'trinta e seis', 'trinta e sete', 'trinta e oito', 'trinta e nove', 'quarenta', 'quarenta e um', 'quarenta e dois', 'quarenta e três', 'quarenta e quatro', 'quarenta e cinco', 'quarenta e seis', 'quarenta e sete', 'quarenta e oito', 'quarenta e nove', 'cinquenta', 'cinquenta e um', 'cinquenta e dois', 'cinquenta e três', 'cinquenta e quatro', 'cinquenta e cinco', 'cinquenta e seis', 'cinquenta e sete', 'cinquenta e oito', 'cinquenta e nove', 'sessenta', 'sessenta e um', 'sessenta e dois', 'sessenta e três', 'sessenta e quatro', 'sessenta e cinco', 'sessenta e seis', 'sessenta e sete', 'sessenta e oito', 'sessenta e nove', 'setenta', 'setenta e um', 'setenta e dois', 'setenta e três', 'setenta e quatro', 'setenta e cinco', 'setenta e seis', 'setenta e sete', 'setenta e oito', 'setenta e nove', 'oitenta', 'oitenta e um', 'oitenta e dois', 'oitenta e três', 'oitenta e quatro', 'oitenta e cinco', 'oitenta e seis', 'oitenta e sete', 'oitenta e oito', 'oitenta e nove', 'noventa', 'noventa e um', 'noventa e dois', 'noventa e três', 'noventa e quatro', 'noventa e cinco', 'noventa e seis', 'noventa e sete', 'noventa e oito', 'noventa e nove', 'cem', 'cento e um', 'cento e dois', 'cento e três', 'cento e quatro', 'cento e cinco', 'cento e seis', 'cento e sete', 'cento e oito', 'cento e nove', 'cento e dez', 'cento e onze', 'cento e doze', 'cento e treze', 'cento e quatorze', 'cento e quinze', 'cento e dezesseis', 'cento e dezessete', 'cento e dezoito', 'cento e dezenove', 'cento e vinte', 'cento e vinte e um', 'cento e vinte e dois', 'cento e vinte e três', 'cento e vinte e quatro', 'cento e vinte e cinco', 'cento e vinte e seis', 'cento e vinte e sete', 'cento e vinte e oito', 'cento e vinte e nove', 'cento e trinta', 'cento e trinta e um', 'cento e trinta e dois', 'cento e trinta e três', 'cento e trinta e quatro', 'cento e trinta e cinco', 'cento e trinta e seis', 'cento e trinta e sete', 'cento e trinta e oito', 'cento e trinta e nove', 'cento e quarenta', 'cento e quarenta e um', 'cento e quarenta e dois', 'cento e quarenta e três', 'cento e quarenta e quatro', 'cento e quarenta e cinco', 'cento e quarenta e seis', 'cento e quarenta e sete', 'cento e quarenta e oito', 'cento e quarenta e nove', 'cento e cinquenta', 'cento e cinquenta e um', 'cento e cinquenta e dois', 'cento e cinquenta e três', 'cento e cinquenta e quatro', 'cento e cinquenta e cinco', 'cento e cinquenta e seis', 'cento e cinquenta e sete', 'cento e cinquenta e oito', 'cento e cinquenta e nove', 'cento e sessenta', 'cento e sessenta e um', 'cento e sessenta e dois', 'cento e sessenta e três', 'cento e sessenta e quatro', 'cento e sessenta e cinco', 'cento e sessenta e seis', 'cento e sessenta e sete', 'cento e sessenta e oito', 'cento e sessenta e nove', 'cento e setenta', 'cento e setenta e um', 'cento e setenta e dois', 'cento e setenta e três', 'cento e setenta e quatro', 'cento e setenta e cinco', 'cento e setenta e seis', 'cento e setenta e sete', 'cento e setenta e oito', 'cento e setenta e nove', 'cento e oitenta', 'cento e oitenta e um', 'cento e oitenta e dois', 'cento e oitenta e três', 'cento e oitenta e quatro', 'cento e oitenta e cinco', 'cento e oitenta e seis', 'cento e oitenta e sete', 'cento e oitenta e oito', 'cento e oitenta e nove', 'cento e noventa', 'cento e noventa e um', 'cento e noventa e dois', 'cento e noventa e três', 'cento e noventa e quatro', 'cento e noventa e cinco', 'cento e noventa e seis', 'cento e noventa e sete', 'cento e noventa e oito', 'cento e noventa e nove', 'duzentos', 'duzentos e um', 'duzentos e dois', 'duzentos e três', 'duzentos e quatro', 'duzentos e cinco', 'duzentos e seis', 'duzentos e sete', 'duzentos e oito', 'duzentos e nove', 'duzentos e dez', 'duzentos e onze', 'duzentos e doze', 'duzentos e treze', 'duzentos e quatorze', 'duzentos e quinze', 'duzentos e dezesseis', 'duzentos e dezessete', 'duzentos e dezoito', 'duzentos e dezenove', 'duzentos e vinte', 'duzentos e vinte e um', 'duzentos e vinte e dois', 'duzentos e vinte e três', 'duzentos e vinte e quatro', 'duzentos e vinte e cinco', 'duzentos e vinte e seis', 'duzentos e vinte e sete', 'duzentos e vinte e oito', 'duzentos e vinte e nove', 'duzentos e trinta', 'duzentos e trinta e um', 'duzentos e trinta e dois', 'duzentos e trinta e três', 'duzentos e trinta e quatro', 'duzentos e trinta e cinco', 'duzentos e trinta e seis', 'duzentos e trinta e sete', 'duzentos e trinta e oito', 'duzentos e trinta e nove', 'duzentos e quarenta', 'duzentos e quarenta e um', 'duzentos e quarenta e dois', 'duzentos e quarenta e três', 'duzentos e quarenta e quatro', 'duzentos e quarenta e cinco', 'duzentos e quarenta e seis', 'duzentos e quarenta e sete', 'duzentos e quarenta e oito', 'duzentos e quarenta e nove', 'duzentos e cinquenta', 'duzentos e cinquenta e um', 'duzentos e cinquenta e dois', 'duzentos e cinquenta e três', 'duzentos e cinquenta e quatro', 'duzentos e cinquenta e cinco', 'duzentos e cinquenta e seis', 'duzentos e cinquenta e sete', 'duzentos e cinquenta e oito', 'duzentos e cinquenta e nove', 'duzentos e sessenta', 'duzentos e sessenta e um', 'duzentos e sessenta e dois', 'duzentos e sessenta e três', 'duzentos e sessenta e quatro', 'duzentos e sessenta e cinco', 'duzentos e sessenta e seis', 'duzentos e sessenta e sete', 'duzentos e sessenta e oito', 'duzentos e sessenta e nove', 'duzentos e setenta', 'duzentos e setenta e um', 'duzentos e setenta e dois', 'duzentos e setenta e três', 'duzentos e setenta e quatro', 'duzentos e setenta e cinco', 'duzentos e setenta e seis', 'duzentos e setenta e sete', 'duzentos e setenta e oito', 'duzentos e setenta e nove', 'duzentos e oitenta', 'duzentos e oitenta e um', 'duzentos e oitenta e dois', 'duzentos e oitenta e três', 'duzentos e oitenta e quatro', 'duzentos e oitenta e cinco', 'duzentos e oitenta e seis', 'duzentos e oitenta e sete', 'duzentos e oitenta e oito', 'duzentos e oitenta e nove', 'duzentos e noventa', 'duzentos e noventa e um', 'duzentos e noventa e dois', 'duzentos e noventa e três', 'duzentos e noventa e quatro', 'duzentos e noventa e cinco', 'duzentos e noventa e seis', 'duzentos e noventa e sete', 'duzentos e noventa e oito', 'duzentos e noventa e nove', 'trezentos', 'trezentos e um', 'trezentos e dois', 'trezentos e três', 'trezentos e quatro', 'trezentos e cinco', 'trezentos e seis', 'trezentos e sete', 'trezentos e oito', 'trezentos e nove', 'trezentos e dez', 'trezentos e onze', 'trezentos e doze', 'trezentos e treze', 'trezentos e quatorze', 'trezentos e quinze', 'trezentos e dezesseis', 'trezentos e dezessete', 'trezentos e dezoito', 'trezentos e dezenove', 'trezentos e vinte', 'trezentos e vinte e um', 'trezentos e vinte e dois', 'trezentos e vinte e três', 'trezentos e vinte e quatro', 'trezentos e vinte e cinco', 'trezentos e vinte e seis', 'trezentos e vinte e sete', 'trezentos e vinte e oito', 'trezentos e vinte e nove', 'trezentos e trinta', 'trezentos e trinta e um', 'trezentos e trinta e dois', 'trezentos e trinta e três', 'trezentos e trinta e quatro', 'trezentos e trinta e cinco', 'trezentos e trinta e seis', 'trezentos e trinta e sete', 'trezentos e trinta e oito', 'trezentos e trinta e nove', 'trezentos e quarenta', 'trezentos e quarenta e um', 'trezentos e quarenta e dois', 'trezentos e quarenta e três', 'trezentos e quarenta e quatro', 'trezentos e quarenta e cinco', 'trezentos e quarenta e seis', 'trezentos e quarenta e sete', 'trezentos e quarenta e oito', 'trezentos e quarenta e nove', 'trezentos e cinquenta', 'trezentos e cinquenta e um', 'trezentos e cinquenta e dois', 'trezentos e cinquenta e três', 'trezentos e cinquenta e quatro', 'trezentos e cinquenta e cinco', 'trezentos e cinquenta e seis', 'trezentos e cinquenta e sete', 'trezentos e cinquenta e oito', 'trezentos e cinquenta e nove', 'trezentos e sessenta', 'trezentos e sessenta e um', 'trezentos e sessenta e dois', 'trezentos e sessenta e três', 'trezentos e sessenta e quatro', 'trezentos e sessenta e cinco', 'trezentos e sessenta e seis', 'trezentos e sessenta e sete', 'trezentos e sessenta e oito', 'trezentos e sessenta e nove', 'trezentos e setenta', 'trezentos e setenta e um', 'trezentos e setenta e dois', 'trezentos e setenta e três', 'trezentos e setenta e quatro', 'trezentos e setenta e cinco', 'trezentos e setenta e seis', 'trezentos e setenta e sete', 'trezentos e setenta e oito', 'trezentos e setenta e nove', 'trezentos e oitenta', 'trezentos e oitenta e um', 'trezentos e oitenta e dois', 'trezentos e oitenta e três', 'trezentos e oitenta e quatro', 'trezentos e oitenta e cinco', 'trezentos e oitenta e seis', 'trezentos e oitenta e sete', 'trezentos e oitenta e oito', 'trezentos e oitenta e nove', 'trezentos e noventa', 'trezentos e noventa e um', 'trezentos e noventa e dois', 'trezentos e noventa e três', 'trezentos e noventa e quatro', 'trezentos e noventa e cinco', 'trezentos e noventa e seis', 'trezentos e noventa e sete', 'trezentos e noventa e oito', 'trezentos e noventa e nove', 'quatrocentos', 'quatrocentos e um', 'quatrocentos e dois', 'quatrocentos e três', 'quatrocentos e quatro', 'quatrocentos e cinco', 'quatrocentos e seis', 'quatrocentos e sete', 'quatrocentos e oito', 'quatrocentos e nove', 'quatrocentos e dez', 'quatrocentos e onze', 'quatrocentos e doze', 'quatrocentos e treze', 'quatrocentos e quatorze', 'quatrocentos e quinze', 'quatrocentos e dezesseis', 'quatrocentos e dezessete', 'quatrocentos e dezoito', 'quatrocentos e dezenove', 'quatrocentos e vinte', 'quatrocentos e vinte e um', 'quatrocentos e vinte e dois', 'quatrocentos e vinte e três', 'quatrocentos e vinte e quatro', 'quatrocentos e vinte e cinco', 'quatrocentos e vinte e seis', 'quatrocentos e vinte e sete', 'quatrocentos e vinte e oito', 'quatrocentos e vinte e nove', 'quatrocentos e trinta', 'quatrocentos e trinta e um', 'quatrocentos e trinta e dois', 'quatrocentos e trinta e três', 'quatrocentos e trinta e quatro', 'quatrocentos e trinta e cinco', 'quatrocentos e trinta e seis', 'quatrocentos e trinta e sete', 'quatrocentos e trinta e oito', 'quatrocentos e trinta e nove', 'quatrocentos e quarenta', 'quatrocentos e quarenta e um', 'quatrocentos e quarenta e dois', 'quatrocentos e quarenta e três', 'quatrocentos e quarenta e quatro', 'quatrocentos e quarenta e cinco', 'quatrocentos e quarenta e seis', 'quatrocentos e quarenta e sete', 'quatrocentos e quarenta e oito', 'quatrocentos e quarenta e nove', 'quatrocentos e cinquenta', 'quatrocentos e cinquenta e um', 'quatrocentos e cinquenta e dois', 'quatrocentos e cinquenta e três', 'quatrocentos e cinquenta e quatro', 'quatrocentos e cinquenta e cinco', 'quatrocentos e cinquenta e seis', 'quatrocentos e cinquenta e sete', 'quatrocentos e cinquenta e oito', 'quatrocentos e cinquenta e nove', 'quatrocentos e sessenta', 'quatrocentos e sessenta e um', 'quatrocentos e sessenta e dois', 'quatrocentos e sessenta e três', 'quatrocentos e sessenta e quatro', 'quatrocentos e sessenta e cinco', 'quatrocentos e sessenta e seis', 'quatrocentos e sessenta e sete', 'quatrocentos e sessenta e oito', 'quatrocentos e sessenta e nove', 'quatrocentos e setenta', 'quatrocentos e setenta e um', 'quatrocentos e setenta e dois', 'quatrocentos e setenta e três', 'quatrocentos e setenta e quatro', 'quatrocentos e setenta e cinco', 'quatrocentos e setenta e seis', 'quatrocentos e setenta e sete', 'quatrocentos e setenta e oito', 'quatrocentos e setenta e nove', 'quatrocentos e oitenta', 'quatrocentos e oitenta e um', 'quatrocentos e oitenta e dois', 'quatrocentos e oitenta e três', 'quatrocentos e oitenta e quatro', 'quatrocentos e oitenta e cinco', 'quatrocentos e oitenta e seis', 'quatrocentos e oitenta e sete', 'quatrocentos e oitenta e oito', 'quatrocentos e oitenta e nove', 'quatrocentos e noventa', 'quatrocentos e noventa e um', 'quatrocentos e noventa e dois', 'quatrocentos e noventa e três', 'quatrocentos e noventa e quatro', 'quatrocentos e noventa e cinco', 'quatrocentos e noventa e seis', 'quatrocentos e noventa e sete', 'quatrocentos e noventa e oito', 'quatrocentos e noventa e nove', 'quinhentos', 'quinhentos e um', 'quinhentos e dois', 'quinhentos e três', 'quinhentos e quatro', 'quinhentos e cinco', 'quinhentos e seis', 'quinhentos e sete', 'quinhentos e oito', 'quinhentos e nove', 'quinhentos e dez', 'quinhentos e onze', 'quinhentos e doze', 'quinhentos e treze', 'quinhentos e quatorze', 'quinhentos e quinze', 'quinhentos e dezesseis', 'quinhentos e dezessete', 'quinhentos e dezoito', 'quinhentos e dezenove', 'quinhentos e vinte', 'quinhentos e vinte e um', 'quinhentos e vinte e dois', 'quinhentos e vinte e três', 'quinhentos e vinte e quatro', 'quinhentos e vinte e cinco', 'quinhentos e vinte e seis', 'quinhentos e vinte e sete', 'quinhentos e vinte e oito', 'quinhentos e vinte e nove', 'quinhentos e trinta', 'quinhentos e trinta e um', 'quinhentos e trinta e dois', 'quinhentos e trinta e três', 'quinhentos e trinta e quatro', 'quinhentos e trinta e cinco', 'quinhentos e trinta e seis', 'quinhentos e trinta e sete', 'quinhentos e trinta e oito', 'quinhentos e trinta e nove', 'quinhentos e quarenta', 'quinhentos e quarenta e um', 'quinhentos e quarenta e dois', 'quinhentos e quarenta e três', 'quinhentos e quarenta e quatro', 'quinhentos e quarenta e cinco', 'quinhentos e quarenta e seis', 'quinhentos e quarenta e sete', 'quinhentos e quarenta e oito', 'quinhentos e quarenta e nove', 'quinhentos e cinquenta', 'quinhentos e cinquenta e um', 'quinhentos e cinquenta e dois', 'quinhentos e cinquenta e três', 'quinhentos e cinquenta e quatro', 'quinhentos e cinquenta e cinco', 'quinhentos e cinquenta e seis', 'quinhentos e cinquenta e sete', 'quinhentos e cinquenta e oito', 'quinhentos e cinquenta e nove', 'quinhentos e sessenta', 'quinhentos e sessenta e um', 'quinhentos e sessenta e dois', 'quinhentos e sessenta e três', 'quinhentos e sessenta e quatro', 'quinhentos e sessenta e cinco', 'quinhentos e sessenta e seis', 'quinhentos e sessenta e sete', 'quinhentos e sessenta e oito', 'quinhentos e sessenta e nove', 'quinhentos e setenta', 'quinhentos e setenta e um', 'quinhentos e setenta e dois', 'quinhentos e setenta e três', 'quinhentos e setenta e quatro', 'quinhentos e setenta e cinco', 'quinhentos e setenta e seis', 'quinhentos e setenta e sete', 'quinhentos e setenta e oito', 'quinhentos e setenta e nove', 'quinhentos e oitenta', 'quinhentos e oitenta e um', 'quinhentos e oitenta e dois', 'quinhentos e oitenta e três', 'quinhentos e oitenta e quatro', 'quinhentos e oitenta e cinco', 'quinhentos e oitenta e seis', 'quinhentos e oitenta e sete', 'quinhentos e oitenta e oito', 'quinhentos e oitenta e nove', 'quinhentos e noventa', 'quinhentos e noventa e um', 'quinhentos e noventa e dois', 'quinhentos e noventa e três', 'quinhentos e noventa e quatro', 'quinhentos e noventa e cinco', 'quinhentos e noventa e seis', 'quinhentos e noventa e sete', 'quinhentos e noventa e oito', 'quinhentos e noventa e nove', 'seiscentos', 'seiscentos e um', 'seiscentos e dois', 'seiscentos e três', 'seiscentos e quatro', 'seiscentos e cinco', 'seiscentos e seis', 'seiscentos e sete', 'seiscentos e oito', 'seiscentos e nove', 'seiscentos e dez', 'seiscentos e onze', 'seiscentos e doze', 'seiscentos e treze', 'seiscentos e quatorze', 'seiscentos e quinze', 'seiscentos e dezesseis', 'seiscentos e dezessete', 'seiscentos e dezoito', 'seiscentos e dezenove', 'seiscentos e vinte', 'seiscentos e vinte e um', 'seiscentos e vinte e dois', 'seiscentos e vinte e três', 'seiscentos e vinte e quatro', 'seiscentos e vinte e cinco', 'seiscentos e vinte e seis', 'seiscentos e vinte e sete', 'seiscentos e vinte e oito', 'seiscentos e vinte e nove', 'seiscentos e trinta', 'seiscentos e trinta e um', 'seiscentos e trinta e dois', 'seiscentos e trinta e três', 'seiscentos e trinta e quatro', 'seiscentos e trinta e cinco', 'seiscentos e trinta e seis', 'seiscentos e trinta e sete', 'seiscentos e trinta e oito', 'seiscentos e trinta e nove', 'seiscentos e quarenta', 'seiscentos e quarenta e um', 'seiscentos e quarenta e dois', 'seiscentos e quarenta e três', 'seiscentos e quarenta e quatro', 'seiscentos e quarenta e cinco', 'seiscentos e quarenta e seis', 'seiscentos e quarenta e sete', 'seiscentos e quarenta e oito', 'seiscentos e quarenta e nove', 'seiscentos e cinquenta', 'seiscentos e cinquenta e um', 'seiscentos e cinquenta e dois', 'seiscentos e cinquenta e três', 'seiscentos e cinquenta e quatro', 'seiscentos e cinquenta e cinco', 'seiscentos e cinquenta e seis', 'seiscentos e cinquenta e sete', 'seiscentos e cinquenta e oito', 'seiscentos e cinquenta e nove', 'seiscentos e sessenta', 'seiscentos e sessenta e um', 'seiscentos e sessenta e dois', 'seiscentos e sessenta e três', 'seiscentos e sessenta e quatro', 'seiscentos e sessenta e cinco', 'seiscentos e sessenta e seis', 'seiscentos e sessenta e sete', 'seiscentos e sessenta e oito', 'seiscentos e sessenta e nove', 'seiscentos e setenta', 'seiscentos e setenta e um', 'seiscentos e setenta e dois', 'seiscentos e setenta e três', 'seiscentos e setenta e quatro', 'seiscentos e setenta e cinco', 'seiscentos e setenta e seis', 'seiscentos e setenta e sete', 'seiscentos e setenta e oito', 'seiscentos e setenta e nove', 'seiscentos e oitenta', 'seiscentos e oitenta e um', 'seiscentos e oitenta e dois', 'seiscentos e oitenta e três', 'seiscentos e oitenta e quatro', 'seiscentos e oitenta e cinco', 'seiscentos e oitenta e seis', 'seiscentos e oitenta e sete', 'seiscentos e oitenta e oito', 'seiscentos e oitenta e nove', 'seiscentos e noventa', 'seiscentos e noventa e um', 'seiscentos e noventa e dois', 'seiscentos e noventa e três', 'seiscentos e noventa e quatro', 'seiscentos e noventa e cinco', 'seiscentos e noventa e seis', 'seiscentos e noventa e sete', 'seiscentos e noventa e oito', 'seiscentos e noventa e nove', 'setecentos', 'setecentos e um', 'setecentos e dois', 'setecentos e três', 'setecentos e quatro', 'setecentos e cinco', 'setecentos e seis', 'setecentos e sete', 'setecentos e oito', 'setecentos e nove', 'setecentos e dez', 'setecentos e onze', 'setecentos e doze', 'setecentos e treze', 'setecentos e quatorze', 'setecentos e quinze', 'setecentos e dezesseis', 'setecentos e dezessete', 'setecentos e dezoito', 'setecentos e dezenove', 'setecentos e vinte', 'setecentos e vinte e um', 'setecentos e vinte e dois', 'setecentos e vinte e três', 'setecentos e vinte e quatro', 'setecentos e vinte e cinco', 'setecentos e vinte e seis', 'setecentos e vinte e sete', 'setecentos e vinte e oito', 'setecentos e vinte e nove', 'setecentos e trinta', 'setecentos e trinta e um', 'setecentos e trinta e dois', 'setecentos e trinta e três', 'setecentos e trinta e quatro', 'setecentos e trinta e cinco', 'setecentos e trinta e seis', 'setecentos e trinta e sete', 'setecentos e trinta e oito', 'setecentos e trinta e nove', 'setecentos e quarenta', 'setecentos e quarenta e um', 'setecentos e quarenta e dois', 'setecentos e quarenta e três', 'setecentos e quarenta e quatro', 'setecentos e quarenta e cinco', 'setecentos e quarenta e seis', 'setecentos e quarenta e sete', 'setecentos e quarenta e oito', 'setecentos e quarenta e nove', 'setecentos e cinquenta', 'setecentos e cinquenta e um', 'setecentos e cinquenta e dois', 'setecentos e cinquenta e três', 'setecentos e cinquenta e quatro', 'setecentos e cinquenta e cinco', 'setecentos e cinquenta e seis', 'setecentos e cinquenta e sete', 'setecentos e cinquenta e oito', 'setecentos e cinquenta e nove', 'setecentos e sessenta', 'setecentos e sessenta e um', 'setecentos e sessenta e dois', 'setecentos e sessenta e três', 'setecentos e sessenta e quatro', 'setecentos e sessenta e cinco', 'setecentos e sessenta e seis', 'setecentos e sessenta e sete', 'setecentos e sessenta e oito', 'setecentos e sessenta e nove', 'setecentos e setenta', 'setecentos e setenta e um', 'setecentos e setenta e dois', 'setecentos e setenta e três', 'setecentos e setenta e quatro', 'setecentos e setenta e cinco', 'setecentos e setenta e seis', 'setecentos e setenta e sete', 'setecentos e setenta e oito', 'setecentos e setenta e nove', 'setecentos e oitenta', 'setecentos e oitenta e um', 'setecentos e oitenta e dois', 'setecentos e oitenta e três', 'setecentos e oitenta e quatro', 'setecentos e oitenta e cinco', 'setecentos e oitenta e seis', 'setecentos e oitenta e sete', 'setecentos e oitenta e oito', 'setecentos e oitenta e nove', 'setecentos e noventa', 'setecentos e noventa e um', 'setecentos e noventa e dois', 'setecentos e noventa e três', 'setecentos e noventa e quatro', 'setecentos e noventa e cinco', 'setecentos e noventa e seis', 'setecentos e noventa e sete', 'setecentos e noventa e oito', 'setecentos e noventa e nove', 'oitocentos', 'oitocentos e um', 'oitocentos e dois', 'oitocentos e três', 'oitocentos e quatro', 'oitocentos e cinco', 'oitocentos e seis', 'oitocentos e sete', 'oitocentos e oito', 'oitocentos e nove', 'oitocentos e dez', 'oitocentos e onze', 'oitocentos e doze', 'oitocentos e treze', 'oitocentos e quatorze', 'oitocentos e quinze', 'oitocentos e dezesseis', 'oitocentos e dezessete', 'oitocentos e dezoito', 'oitocentos e dezenove', 'oitocentos e vinte', 'oitocentos e vinte e um', 'oitocentos e vinte e dois', 'oitocentos e vinte e três', 'oitocentos e vinte e quatro', 'oitocentos e vinte e cinco', 'oitocentos e vinte e seis', 'oitocentos e vinte e sete', 'oitocentos e vinte e oito', 'oitocentos e vinte e nove', 'oitocentos e trinta', 'oitocentos e trinta e um', 'oitocentos e trinta e dois', 'oitocentos e trinta e três', 'oitocentos e trinta e quatro', 'oitocentos e trinta e cinco', 'oitocentos e trinta e seis', 'oitocentos e trinta e sete', 'oitocentos e trinta e oito', 'oitocentos e trinta e nove', 'oitocentos e quarenta', 'oitocentos e quarenta e um', 'oitocentos e quarenta e dois', 'oitocentos e quarenta e três', 'oitocentos e quarenta e quatro', 'oitocentos e quarenta e cinco', 'oitocentos e quarenta e seis', 'oitocentos e quarenta e sete', 'oitocentos e quarenta e oito', 'oitocentos e quarenta e nove', 'oitocentos e cinquenta', 'oitocentos e cinquenta e um', 'oitocentos e cinquenta e dois', 'oitocentos e cinquenta e três', 'oitocentos e cinquenta e quatro', 'oitocentos e cinquenta e cinco', 'oitocentos e cinquenta e seis', 'oitocentos e cinquenta e sete', 'oitocentos e cinquenta e oito', 'oitocentos e cinquenta e nove', 'oitocentos e sessenta', 'oitocentos e sessenta e um', 'oitocentos e sessenta e dois', 'oitocentos e sessenta e três', 'oitocentos e sessenta e quatro', 'oitocentos e sessenta e cinco', 'oitocentos e sessenta e seis', 'oitocentos e sessenta e sete', 'oitocentos e sessenta e oito', 'oitocentos e sessenta e nove', 'oitocentos e setenta', 'oitocentos e setenta e um', 'oitocentos e setenta e dois', 'oitocentos e setenta e três', 'oitocentos e setenta e quatro', 'oitocentos e setenta e cinco', 'oitocentos e setenta e seis', 'oitocentos e setenta e sete', 'oitocentos e setenta e oito', 'oitocentos e setenta e nove', 'oitocentos e oitenta', 'oitocentos e oitenta e um', 'oitocentos e oitenta e dois', 'oitocentos e oitenta e três', 'oitocentos e oitenta e quatro', 'oitocentos e oitenta e cinco', 'oitocentos e oitenta e seis', 'oitocentos e oitenta e sete', 'oitocentos e oitenta e oito', 'oitocentos e oitenta e nove', 'oitocentos e noventa', 'oitocentos e noventa e um', 'oitocentos e noventa e dois', 'oitocentos e noventa e três', 'oitocentos e noventa e quatro', 'oitocentos e noventa e cinco', 'oitocentos e noventa e seis', 'oitocentos e noventa e sete', 'oitocentos e noventa e oito', 'oitocentos e noventa e nove', 'novecentos', 'novecentos e um', 'novecentos e dois', 'novecentos e três', 'novecentos e quatro', 'novecentos e cinco', 'novecentos e seis', 'novecentos e sete', 'novecentos e oito', 'novecentos e nove', 'novecentos e dez', 'novecentos e onze', 'novecentos e doze', 'novecentos e treze', 'novecentos e quatorze', 'novecentos e quinze', 'novecentos e dezesseis', 'novecentos e dezessete', 'novecentos e dezoito', 'novecentos e dezenove', 'novecentos e vinte', 'novecentos e vinte e um', 'novecentos e vinte e dois', 'novecentos e vinte e três', 'novecentos e vinte e quatro', 'novecentos e vinte e cinco', 'novecentos e vinte e seis', 'novecentos e vinte e sete', 'novecentos e vinte e oito', 'novecentos e vinte e nove', 'novecentos e trinta', 'novecentos e trinta e um', 'novecentos e trinta e dois', 'novecentos e trinta e três', 'novecentos e trinta e quatro', 'novecentos e trinta e cinco', 'novecentos e trinta e seis', 'novecentos e trinta e sete', 'novecentos e trinta e oito', 'novecentos e trinta e nove', 'novecentos e quarenta', 'novecentos e quarenta e um', 'novecentos e quarenta e dois', 'novecentos e quarenta e três', 'novecentos e quarenta e quatro', 'novecentos e quarenta e cinco', 'novecentos e quarenta e seis', 'novecentos e quarenta e sete', 'novecentos e quarenta e oito', 'novecentos e quarenta e nove', 'novecentos e cinquenta', 'novecentos e cinquenta e um', 'novecentos e cinquenta e dois', 'novecentos e cinquenta e três', 'novecentos e cinquenta e quatro', 'novecentos e cinquenta e cinco', 'novecentos e cinquenta e seis', 'novecentos e cinquenta e sete', 'novecentos e cinquenta e oito', 'novecentos e cinquenta e nove', 'novecentos e sessenta', 'novecentos e sessenta e um', 'novecentos e sessenta e dois', 'novecentos e sessenta e três', 'novecentos e sessenta e quatro', 'novecentos e sessenta e cinco', 'novecentos e sessenta e seis', 'novecentos e sessenta e sete', 'novecentos e sessenta e oito', 'novecentos e sessenta e nove', 'novecentos e setenta', 'novecentos e setenta e um', 'novecentos e setenta e dois', 'novecentos e setenta e três', 'novecentos e setenta e quatro', 'novecentos e setenta e cinco', 'novecentos e setenta e seis', 'novecentos e setenta e sete', 'novecentos e setenta e oito', 'novecentos e setenta e nove', 'novecentos e oitenta', 'novecentos e oitenta e um', 'novecentos e oitenta e dois', 'novecentos e oitenta e três', 'novecentos e oitenta e quatro', 'novecentos e oitenta e cinco', 'novecentos e oitenta e seis', 'novecentos e oitenta e sete', 'novecentos e oitenta e oito', 'novecentos e oitenta e nove', 'novecentos e noventa', 'novecentos e noventa e um', 'novecentos e noventa e dois', 'novecentos e noventa e três', 'novecentos e noventa e quatro', 'novecentos e noventa e cinco', 'novecentos e noventa e seis', 'novecentos e noventa e sete', 'novecentos e noventa e oito', 'novecentos e noventa e nove'].freeze
  end
end
