module Humanize
  class Tr
    POINT = "virgül".freeze
    INFINITY = 'sonsuz'.freeze
    UNDEFINED = 'tanımsız'.freeze
    NEGATIVE = 'eksi'.freeze
    LOTS = [nil, 'bin', 'milyon', 'milyar', 'trilyon', 'katrilyon', 'kentilyon', 'seksilyon', 'septilyon', 'oktilyon', 'nonilyon', 'desilyon', 'undesilyon', 'dodesilyon', 'tredesilyon', 'katordesilyon', 'kendesilyon', 'seksdesilyon', 'septendesilyon', 'oktodesilyon', 'novemdesilyon', 'vigintilyon'].freeze
    SUB_ONE_GROUPING = ['sıfır', 'bir', 'iki', 'üç', 'dört', 'beş', 'altı', 'yedi', 'sekiz', 'dokuz', 'on', 'on bir', 'on iki', 'on üç', 'on dört', 'on beş', 'on altı', 'on yedi', 'on sekiz', 'on dokuz', 'yirmi', 'yirmi bir', 'yirmi iki', 'yirmi üç', 'yirmi dört', 'yirmi beş', 'yirmi altı', 'yirmi yedi', 'yirmi sekiz', 'yirmi dokuz', 'otuz', 'otuz bir', 'otuz iki', 'otuz üç', 'otuz dört', 'otuz beş', 'otuz altı', 'otuz yedi', 'otuz sekiz', 'otuz dokuz', 'kırk', 'kırk bir', 'kırk iki', 'kırk üç', 'kırk dört', 'kırk beş', 'kırk altı', 'kırk yedi', 'kırk sekiz', 'kırk dokuz', 'elli', 'elli bir', 'elli iki', 'elli üç', 'elli dört', 'elli beş', 'elli altı', 'elli yedi', 'elli sekiz', 'elli dokuz', 'altmış', 'altmış bir', 'altmış iki', 'altmış üç', 'altmış dört', 'altmış beş', 'altmış altı', 'altmış yedi', 'altmış sekiz', 'altmış dokuz', 'yetmiş', 'yetmiş bir', 'yetmiş iki', 'yetmiş üç', 'yetmiş dört', 'yetmiş beş', 'yetmiş altı', 'yetmiş yedi', 'yetmiş sekiz', 'yetmiş dokuz', 'seksen', 'seksen bir', 'seksen iki', 'seksen üç', 'seksen dört', 'seksen beş', 'seksen altı', 'seksen yedi', 'seksen sekiz', 'seksen dokuz', 'doksan', 'doksan bir', 'doksan iki', 'doksan üç', 'doksan dört', 'doksan beş', 'doksan altı', 'doksan yedi', 'doksan sekiz', 'doksan dokuz', 'yüz', 'yüz bir', 'yüz iki', 'yüz üç', 'yüz dört', 'yüz beş', 'yüz altı', 'yüz yedi', 'yüz sekiz', 'yüz dokuz', 'yüz on', 'yüz on bir', 'yüz on iki', 'yüz on üç', 'yüz on dört', 'yüz on beş', 'yüz on altı', 'yüz on yedi', 'yüz on sekiz', 'yüz on dokuz', 'yüz yirmi', 'yüz yirmi bir', 'yüz yirmi iki', 'yüz yirmi üç', 'yüz yirmi dört', 'yüz yirmi beş', 'yüz yirmi altı', 'yüz yirmi yedi', 'yüz yirmi sekiz', 'yüz yirmi dokuz', 'yüz otuz', 'yüz otuz bir', 'yüz otuz iki', 'yüz otuz üç', 'yüz otuz dört', 'yüz otuz beş', 'yüz otuz altı', 'yüz otuz yedi', 'yüz otuz sekiz', 'yüz otuz dokuz', 'yüz kırk', 'yüz kırk bir', 'yüz kırk iki', 'yüz kırk üç', 'yüz kırk dört', 'yüz kırk beş', 'yüz kırk altı', 'yüz kırk yedi', 'yüz kırk sekiz', 'yüz kırk dokuz', 'yüz elli', 'yüz elli bir', 'yüz elli iki', 'yüz elli üç', 'yüz elli dört', 'yüz elli beş', 'yüz elli altı', 'yüz elli yedi', 'yüz elli sekiz', 'yüz elli dokuz', 'yüz altmış', 'yüz altmış bir', 'yüz altmış iki', 'yüz altmış üç', 'yüz altmış dört', 'yüz altmış beş', 'yüz altmış altı', 'yüz altmış yedi', 'yüz altmış sekiz', 'yüz altmış dokuz', 'yüz yetmiş', 'yüz yetmiş bir', 'yüz yetmiş iki', 'yüz yetmiş üç', 'yüz yetmiş dört', 'yüz yetmiş beş', 'yüz yetmiş altı', 'yüz yetmiş yedi', 'yüz yetmiş sekiz', 'yüz yetmiş dokuz', 'yüz seksen', 'yüz seksen bir', 'yüz seksen iki', 'yüz seksen üç', 'yüz seksen dört', 'yüz seksen beş', 'yüz seksen altı', 'yüz seksen yedi', 'yüz seksen sekiz', 'yüz seksen dokuz', 'yüz doksan', 'yüz doksan bir', 'yüz doksan iki', 'yüz doksan üç', 'yüz doksan dört', 'yüz doksan beş', 'yüz doksan altı', 'yüz doksan yedi', 'yüz doksan sekiz', 'yüz doksan dokuz', 'iki yüz', 'iki yüz bir', 'iki yüz iki', 'iki yüz üç', 'iki yüz dört', 'iki yüz beş', 'iki yüz altı', 'iki yüz yedi', 'iki yüz sekiz', 'iki yüz dokuz', 'iki yüz on', 'iki yüz on bir', 'iki yüz on iki', 'iki yüz on üç', 'iki yüz on dört', 'iki yüz on beş', 'iki yüz on altı', 'iki yüz on yedi', 'iki yüz on sekiz', 'iki yüz on dokuz', 'iki yüz yirmi', 'iki yüz yirmi bir', 'iki yüz yirmi iki', 'iki yüz yirmi üç', 'iki yüz yirmi dört', 'iki yüz yirmi beş', 'iki yüz yirmi altı', 'iki yüz yirmi yedi', 'iki yüz yirmi sekiz', 'iki yüz yirmi dokuz', 'iki yüz otuz', 'iki yüz otuz bir', 'iki yüz otuz iki', 'iki yüz otuz üç', 'iki yüz otuz dört', 'iki yüz otuz beş', 'iki yüz otuz altı', 'iki yüz otuz yedi', 'iki yüz otuz sekiz', 'iki yüz otuz dokuz', 'iki yüz kırk', 'iki yüz kırk bir', 'iki yüz kırk iki', 'iki yüz kırk üç', 'iki yüz kırk dört', 'iki yüz kırk beş', 'iki yüz kırk altı', 'iki yüz kırk yedi', 'iki yüz kırk sekiz', 'iki yüz kırk dokuz', 'iki yüz elli', 'iki yüz elli bir', 'iki yüz elli iki', 'iki yüz elli üç', 'iki yüz elli dört', 'iki yüz elli beş', 'iki yüz elli altı', 'iki yüz elli yedi', 'iki yüz elli sekiz', 'iki yüz elli dokuz', 'iki yüz altmış', 'iki yüz altmış bir', 'iki yüz altmış iki', 'iki yüz altmış üç', 'iki yüz altmış dört', 'iki yüz altmış beş', 'iki yüz altmış altı', 'iki yüz altmış yedi', 'iki yüz altmış sekiz', 'iki yüz altmış dokuz', 'iki yüz yetmiş', 'iki yüz yetmiş bir', 'iki yüz yetmiş iki', 'iki yüz yetmiş üç', 'iki yüz yetmiş dört', 'iki yüz yetmiş beş', 'iki yüz yetmiş altı', 'iki yüz yetmiş yedi', 'iki yüz yetmiş sekiz', 'iki yüz yetmiş dokuz', 'iki yüz seksen', 'iki yüz seksen bir', 'iki yüz seksen iki', 'iki yüz seksen üç', 'iki yüz seksen dört', 'iki yüz seksen beş', 'iki yüz seksen altı', 'iki yüz seksen yedi', 'iki yüz seksen sekiz', 'iki yüz seksen dokuz', 'iki yüz doksan', 'iki yüz doksan bir', 'iki yüz doksan iki', 'iki yüz doksan üç', 'iki yüz doksan dört', 'iki yüz doksan beş', 'iki yüz doksan altı', 'iki yüz doksan yedi', 'iki yüz doksan sekiz', 'iki yüz doksan dokuz', 'üç yüz', 'üç yüz bir', 'üç yüz iki', 'üç yüz üç', 'üç yüz dört', 'üç yüz beş', 'üç yüz altı', 'üç yüz yedi', 'üç yüz sekiz', 'üç yüz dokuz', 'üç yüz on', 'üç yüz on bir', 'üç yüz on iki', 'üç yüz on üç', 'üç yüz on dört', 'üç yüz on beş', 'üç yüz on altı', 'üç yüz on yedi', 'üç yüz on sekiz', 'üç yüz on dokuz', 'üç yüz yirmi', 'üç yüz yirmi bir', 'üç yüz yirmi iki', 'üç yüz yirmi üç', 'üç yüz yirmi dört', 'üç yüz yirmi beş', 'üç yüz yirmi altı', 'üç yüz yirmi yedi', 'üç yüz yirmi sekiz', 'üç yüz yirmi dokuz', 'üç yüz otuz', 'üç yüz otuz bir', 'üç yüz otuz iki', 'üç yüz otuz üç', 'üç yüz otuz dört', 'üç yüz otuz beş', 'üç yüz otuz altı', 'üç yüz otuz yedi', 'üç yüz otuz sekiz', 'üç yüz otuz dokuz', 'üç yüz kırk', 'üç yüz kırk bir', 'üç yüz kırk iki', 'üç yüz kırk üç', 'üç yüz kırk dört', 'üç yüz kırk beş', 'üç yüz kırk altı', 'üç yüz kırk yedi', 'üç yüz kırk sekiz', 'üç yüz kırk dokuz', 'üç yüz elli', 'üç yüz elli bir', 'üç yüz elli iki', 'üç yüz elli üç', 'üç yüz elli dört', 'üç yüz elli beş', 'üç yüz elli altı', 'üç yüz elli yedi', 'üç yüz elli sekiz', 'üç yüz elli dokuz', 'üç yüz altmış', 'üç yüz altmış bir', 'üç yüz altmış iki', 'üç yüz altmış üç', 'üç yüz altmış dört', 'üç yüz altmış beş', 'üç yüz altmış altı', 'üç yüz altmış yedi', 'üç yüz altmış sekiz', 'üç yüz altmış dokuz', 'üç yüz yetmiş', 'üç yüz yetmiş bir', 'üç yüz yetmiş iki', 'üç yüz yetmiş üç', 'üç yüz yetmiş dört', 'üç yüz yetmiş beş', 'üç yüz yetmiş altı', 'üç yüz yetmiş yedi', 'üç yüz yetmiş sekiz', 'üç yüz yetmiş dokuz', 'üç yüz seksen', 'üç yüz seksen bir', 'üç yüz seksen iki', 'üç yüz seksen üç', 'üç yüz seksen dört', 'üç yüz seksen beş', 'üç yüz seksen altı', 'üç yüz seksen yedi', 'üç yüz seksen sekiz', 'üç yüz seksen dokuz', 'üç yüz doksan', 'üç yüz doksan bir', 'üç yüz doksan iki', 'üç yüz doksan üç', 'üç yüz doksan dört', 'üç yüz doksan beş', 'üç yüz doksan altı', 'üç yüz doksan yedi', 'üç yüz doksan sekiz', 'üç yüz doksan dokuz', 'dört yüz', 'dört yüz bir', 'dört yüz iki', 'dört yüz üç', 'dört yüz dört', 'dört yüz beş', 'dört yüz altı', 'dört yüz yedi', 'dört yüz sekiz', 'dört yüz dokuz', 'dört yüz on', 'dört yüz on bir', 'dört yüz on iki', 'dört yüz on üç', 'dört yüz on dört', 'dört yüz on beş', 'dört yüz on altı', 'dört yüz on yedi', 'dört yüz on sekiz', 'dört yüz on dokuz', 'dört yüz yirmi', 'dört yüz yirmi bir', 'dört yüz yirmi iki', 'dört yüz yirmi üç', 'dört yüz yirmi dört', 'dört yüz yirmi beş', 'dört yüz yirmi altı', 'dört yüz yirmi yedi', 'dört yüz yirmi sekiz', 'dört yüz yirmi dokuz', 'dört yüz otuz', 'dört yüz otuz bir', 'dört yüz otuz iki', 'dört yüz otuz üç', 'dört yüz otuz dört', 'dört yüz otuz beş', 'dört yüz otuz altı', 'dört yüz otuz yedi', 'dört yüz otuz sekiz', 'dört yüz otuz dokuz', 'dört yüz kırk', 'dört yüz kırk bir', 'dört yüz kırk iki', 'dört yüz kırk üç', 'dört yüz kırk dört', 'dört yüz kırk beş', 'dört yüz kırk altı', 'dört yüz kırk yedi', 'dört yüz kırk sekiz', 'dört yüz kırk dokuz', 'dört yüz elli', 'dört yüz elli bir', 'dört yüz elli iki', 'dört yüz elli üç', 'dört yüz elli dört', 'dört yüz elli beş', 'dört yüz elli altı', 'dört yüz elli yedi', 'dört yüz elli sekiz', 'dört yüz elli dokuz', 'dört yüz altmış', 'dört yüz altmış bir', 'dört yüz altmış iki', 'dört yüz altmış üç', 'dört yüz altmış dört', 'dört yüz altmış beş', 'dört yüz altmış altı', 'dört yüz altmış yedi', 'dört yüz altmış sekiz', 'dört yüz altmış dokuz', 'dört yüz yetmiş', 'dört yüz yetmiş bir', 'dört yüz yetmiş iki', 'dört yüz yetmiş üç', 'dört yüz yetmiş dört', 'dört yüz yetmiş beş', 'dört yüz yetmiş altı', 'dört yüz yetmiş yedi', 'dört yüz yetmiş sekiz', 'dört yüz yetmiş dokuz', 'dört yüz seksen', 'dört yüz seksen bir', 'dört yüz seksen iki', 'dört yüz seksen üç', 'dört yüz seksen dört', 'dört yüz seksen beş', 'dört yüz seksen altı', 'dört yüz seksen yedi', 'dört yüz seksen sekiz', 'dört yüz seksen dokuz', 'dört yüz doksan', 'dört yüz doksan bir', 'dört yüz doksan iki', 'dört yüz doksan üç', 'dört yüz doksan dört', 'dört yüz doksan beş', 'dört yüz doksan altı', 'dört yüz doksan yedi', 'dört yüz doksan sekiz', 'dört yüz doksan dokuz', 'beş yüz', 'beş yüz bir', 'beş yüz iki', 'beş yüz üç', 'beş yüz dört', 'beş yüz beş', 'beş yüz altı', 'beş yüz yedi', 'beş yüz sekiz', 'beş yüz dokuz', 'beş yüz on', 'beş yüz on bir', 'beş yüz on iki', 'beş yüz on üç', 'beş yüz on dört', 'beş yüz on beş', 'beş yüz on altı', 'beş yüz on yedi', 'beş yüz on sekiz', 'beş yüz on dokuz', 'beş yüz yirmi', 'beş yüz yirmi bir', 'beş yüz yirmi iki', 'beş yüz yirmi üç', 'beş yüz yirmi dört', 'beş yüz yirmi beş', 'beş yüz yirmi altı', 'beş yüz yirmi yedi', 'beş yüz yirmi sekiz', 'beş yüz yirmi dokuz', 'beş yüz otuz', 'beş yüz otuz bir', 'beş yüz otuz iki', 'beş yüz otuz üç', 'beş yüz otuz dört', 'beş yüz otuz beş', 'beş yüz otuz altı', 'beş yüz otuz yedi', 'beş yüz otuz sekiz', 'beş yüz otuz dokuz', 'beş yüz kırk', 'beş yüz kırk bir', 'beş yüz kırk iki', 'beş yüz kırk üç', 'beş yüz kırk dört', 'beş yüz kırk beş', 'beş yüz kırk altı', 'beş yüz kırk yedi', 'beş yüz kırk sekiz', 'beş yüz kırk dokuz', 'beş yüz elli', 'beş yüz elli bir', 'beş yüz elli iki', 'beş yüz elli üç', 'beş yüz elli dört', 'beş yüz elli beş', 'beş yüz elli altı', 'beş yüz elli yedi', 'beş yüz elli sekiz', 'beş yüz elli dokuz', 'beş yüz altmış', 'beş yüz altmış bir', 'beş yüz altmış iki', 'beş yüz altmış üç', 'beş yüz altmış dört', 'beş yüz altmış beş', 'beş yüz altmış altı', 'beş yüz altmış yedi', 'beş yüz altmış sekiz', 'beş yüz altmış dokuz', 'beş yüz yetmiş', 'beş yüz yetmiş bir', 'beş yüz yetmiş iki', 'beş yüz yetmiş üç', 'beş yüz yetmiş dört', 'beş yüz yetmiş beş', 'beş yüz yetmiş altı', 'beş yüz yetmiş yedi', 'beş yüz yetmiş sekiz', 'beş yüz yetmiş dokuz', 'beş yüz seksen', 'beş yüz seksen bir', 'beş yüz seksen iki', 'beş yüz seksen üç', 'beş yüz seksen dört', 'beş yüz seksen beş', 'beş yüz seksen altı', 'beş yüz seksen yedi', 'beş yüz seksen sekiz', 'beş yüz seksen dokuz', 'beş yüz doksan', 'beş yüz doksan bir', 'beş yüz doksan iki', 'beş yüz doksan üç', 'beş yüz doksan dört', 'beş yüz doksan beş', 'beş yüz doksan altı', 'beş yüz doksan yedi', 'beş yüz doksan sekiz', 'beş yüz doksan dokuz', 'altı yüz', 'altı yüz bir', 'altı yüz iki', 'altı yüz üç', 'altı yüz dört', 'altı yüz beş', 'altı yüz altı', 'altı yüz yedi', 'altı yüz sekiz', 'altı yüz dokuz', 'altı yüz on', 'altı yüz on bir', 'altı yüz on iki', 'altı yüz on üç', 'altı yüz on dört', 'altı yüz on beş', 'altı yüz on altı', 'altı yüz on yedi', 'altı yüz on sekiz', 'altı yüz on dokuz', 'altı yüz yirmi', 'altı yüz yirmi bir', 'altı yüz yirmi iki', 'altı yüz yirmi üç', 'altı yüz yirmi dört', 'altı yüz yirmi beş', 'altı yüz yirmi altı', 'altı yüz yirmi yedi', 'altı yüz yirmi sekiz', 'altı yüz yirmi dokuz', 'altı yüz otuz', 'altı yüz otuz bir', 'altı yüz otuz iki', 'altı yüz otuz üç', 'altı yüz otuz dört', 'altı yüz otuz beş', 'altı yüz otuz altı', 'altı yüz otuz yedi', 'altı yüz otuz sekiz', 'altı yüz otuz dokuz', 'altı yüz kırk', 'altı yüz kırk bir', 'altı yüz kırk iki', 'altı yüz kırk üç', 'altı yüz kırk dört', 'altı yüz kırk beş', 'altı yüz kırk altı', 'altı yüz kırk yedi', 'altı yüz kırk sekiz', 'altı yüz kırk dokuz', 'altı yüz elli', 'altı yüz elli bir', 'altı yüz elli iki', 'altı yüz elli üç', 'altı yüz elli dört', 'altı yüz elli beş', 'altı yüz elli altı', 'altı yüz elli yedi', 'altı yüz elli sekiz', 'altı yüz elli dokuz', 'altı yüz altmış', 'altı yüz altmış bir', 'altı yüz altmış iki', 'altı yüz altmış üç', 'altı yüz altmış dört', 'altı yüz altmış beş', 'altı yüz altmış altı', 'altı yüz altmış yedi', 'altı yüz altmış sekiz', 'altı yüz altmış dokuz', 'altı yüz yetmiş', 'altı yüz yetmiş bir', 'altı yüz yetmiş iki', 'altı yüz yetmiş üç', 'altı yüz yetmiş dört', 'altı yüz yetmiş beş', 'altı yüz yetmiş altı', 'altı yüz yetmiş yedi', 'altı yüz yetmiş sekiz', 'altı yüz yetmiş dokuz', 'altı yüz seksen', 'altı yüz seksen bir', 'altı yüz seksen iki', 'altı yüz seksen üç', 'altı yüz seksen dört', 'altı yüz seksen beş', 'altı yüz seksen altı', 'altı yüz seksen yedi', 'altı yüz seksen sekiz', 'altı yüz seksen dokuz', 'altı yüz doksan', 'altı yüz doksan bir', 'altı yüz doksan iki', 'altı yüz doksan üç', 'altı yüz doksan dört', 'altı yüz doksan beş', 'altı yüz doksan altı', 'altı yüz doksan yedi', 'altı yüz doksan sekiz', 'altı yüz doksan dokuz', 'yedi yüz', 'yedi yüz bir', 'yedi yüz iki', 'yedi yüz üç', 'yedi yüz dört', 'yedi yüz beş', 'yedi yüz altı', 'yedi yüz yedi', 'yedi yüz sekiz', 'yedi yüz dokuz', 'yedi yüz on', 'yedi yüz on bir', 'yedi yüz on iki', 'yedi yüz on üç', 'yedi yüz on dört', 'yedi yüz on beş', 'yedi yüz on altı', 'yedi yüz on yedi', 'yedi yüz on sekiz', 'yedi yüz on dokuz', 'yedi yüz yirmi', 'yedi yüz yirmi bir', 'yedi yüz yirmi iki', 'yedi yüz yirmi üç', 'yedi yüz yirmi dört', 'yedi yüz yirmi beş', 'yedi yüz yirmi altı', 'yedi yüz yirmi yedi', 'yedi yüz yirmi sekiz', 'yedi yüz yirmi dokuz', 'yedi yüz otuz', 'yedi yüz otuz bir', 'yedi yüz otuz iki', 'yedi yüz otuz üç', 'yedi yüz otuz dört', 'yedi yüz otuz beş', 'yedi yüz otuz altı', 'yedi yüz otuz yedi', 'yedi yüz otuz sekiz', 'yedi yüz otuz dokuz', 'yedi yüz kırk', 'yedi yüz kırk bir', 'yedi yüz kırk iki', 'yedi yüz kırk üç', 'yedi yüz kırk dört', 'yedi yüz kırk beş', 'yedi yüz kırk altı', 'yedi yüz kırk yedi', 'yedi yüz kırk sekiz', 'yedi yüz kırk dokuz', 'yedi yüz elli', 'yedi yüz elli bir', 'yedi yüz elli iki', 'yedi yüz elli üç', 'yedi yüz elli dört', 'yedi yüz elli beş', 'yedi yüz elli altı', 'yedi yüz elli yedi', 'yedi yüz elli sekiz', 'yedi yüz elli dokuz', 'yedi yüz altmış', 'yedi yüz altmış bir', 'yedi yüz altmış iki', 'yedi yüz altmış üç', 'yedi yüz altmış dört', 'yedi yüz altmış beş', 'yedi yüz altmış altı', 'yedi yüz altmış yedi', 'yedi yüz altmış sekiz', 'yedi yüz altmış dokuz', 'yedi yüz yetmiş', 'yedi yüz yetmiş bir', 'yedi yüz yetmiş iki', 'yedi yüz yetmiş üç', 'yedi yüz yetmiş dört', 'yedi yüz yetmiş beş', 'yedi yüz yetmiş altı', 'yedi yüz yetmiş yedi', 'yedi yüz yetmiş sekiz', 'yedi yüz yetmiş dokuz', 'yedi yüz seksen', 'yedi yüz seksen bir', 'yedi yüz seksen iki', 'yedi yüz seksen üç', 'yedi yüz seksen dört', 'yedi yüz seksen beş', 'yedi yüz seksen altı', 'yedi yüz seksen yedi', 'yedi yüz seksen sekiz', 'yedi yüz seksen dokuz', 'yedi yüz doksan', 'yedi yüz doksan bir', 'yedi yüz doksan iki', 'yedi yüz doksan üç', 'yedi yüz doksan dört', 'yedi yüz doksan beş', 'yedi yüz doksan altı', 'yedi yüz doksan yedi', 'yedi yüz doksan sekiz', 'yedi yüz doksan dokuz', 'sekiz yüz', 'sekiz yüz bir', 'sekiz yüz iki', 'sekiz yüz üç', 'sekiz yüz dört', 'sekiz yüz beş', 'sekiz yüz altı', 'sekiz yüz yedi', 'sekiz yüz sekiz', 'sekiz yüz dokuz', 'sekiz yüz on', 'sekiz yüz on bir', 'sekiz yüz on iki', 'sekiz yüz on üç', 'sekiz yüz on dört', 'sekiz yüz on beş', 'sekiz yüz on altı', 'sekiz yüz on yedi', 'sekiz yüz on sekiz', 'sekiz yüz on dokuz', 'sekiz yüz yirmi', 'sekiz yüz yirmi bir', 'sekiz yüz yirmi iki', 'sekiz yüz yirmi üç', 'sekiz yüz yirmi dört', 'sekiz yüz yirmi beş', 'sekiz yüz yirmi altı', 'sekiz yüz yirmi yedi', 'sekiz yüz yirmi sekiz', 'sekiz yüz yirmi dokuz', 'sekiz yüz otuz', 'sekiz yüz otuz bir', 'sekiz yüz otuz iki', 'sekiz yüz otuz üç', 'sekiz yüz otuz dört', 'sekiz yüz otuz beş', 'sekiz yüz otuz altı', 'sekiz yüz otuz yedi', 'sekiz yüz otuz sekiz', 'sekiz yüz otuz dokuz', 'sekiz yüz kırk', 'sekiz yüz kırk bir', 'sekiz yüz kırk iki', 'sekiz yüz kırk üç', 'sekiz yüz kırk dört', 'sekiz yüz kırk beş', 'sekiz yüz kırk altı', 'sekiz yüz kırk yedi', 'sekiz yüz kırk sekiz', 'sekiz yüz kırk dokuz', 'sekiz yüz elli', 'sekiz yüz elli bir', 'sekiz yüz elli iki', 'sekiz yüz elli üç', 'sekiz yüz elli dört', 'sekiz yüz elli beş', 'sekiz yüz elli altı', 'sekiz yüz elli yedi', 'sekiz yüz elli sekiz', 'sekiz yüz elli dokuz', 'sekiz yüz altmış', 'sekiz yüz altmış bir', 'sekiz yüz altmış iki', 'sekiz yüz altmış üç', 'sekiz yüz altmış dört', 'sekiz yüz altmış beş', 'sekiz yüz altmış altı', 'sekiz yüz altmış yedi', 'sekiz yüz altmış sekiz', 'sekiz yüz altmış dokuz', 'sekiz yüz yetmiş', 'sekiz yüz yetmiş bir', 'sekiz yüz yetmiş iki', 'sekiz yüz yetmiş üç', 'sekiz yüz yetmiş dört', 'sekiz yüz yetmiş beş', 'sekiz yüz yetmiş altı', 'sekiz yüz yetmiş yedi', 'sekiz yüz yetmiş sekiz', 'sekiz yüz yetmiş dokuz', 'sekiz yüz seksen', 'sekiz yüz seksen bir', 'sekiz yüz seksen iki', 'sekiz yüz seksen üç', 'sekiz yüz seksen dört', 'sekiz yüz seksen beş', 'sekiz yüz seksen altı', 'sekiz yüz seksen yedi', 'sekiz yüz seksen sekiz', 'sekiz yüz seksen dokuz', 'sekiz yüz doksan', 'sekiz yüz doksan bir', 'sekiz yüz doksan iki', 'sekiz yüz doksan üç', 'sekiz yüz doksan dört', 'sekiz yüz doksan beş', 'sekiz yüz doksan altı', 'sekiz yüz doksan yedi', 'sekiz yüz doksan sekiz', 'sekiz yüz doksan dokuz', 'dokuz yüz', 'dokuz yüz bir', 'dokuz yüz iki', 'dokuz yüz üç', 'dokuz yüz dört', 'dokuz yüz beş', 'dokuz yüz altı', 'dokuz yüz yedi', 'dokuz yüz sekiz', 'dokuz yüz dokuz', 'dokuz yüz on', 'dokuz yüz on bir', 'dokuz yüz on iki', 'dokuz yüz on üç', 'dokuz yüz on dört', 'dokuz yüz on beş', 'dokuz yüz on altı', 'dokuz yüz on yedi', 'dokuz yüz on sekiz', 'dokuz yüz on dokuz', 'dokuz yüz yirmi', 'dokuz yüz yirmi bir', 'dokuz yüz yirmi iki', 'dokuz yüz yirmi üç', 'dokuz yüz yirmi dört', 'dokuz yüz yirmi beş', 'dokuz yüz yirmi altı', 'dokuz yüz yirmi yedi', 'dokuz yüz yirmi sekiz', 'dokuz yüz yirmi dokuz', 'dokuz yüz otuz', 'dokuz yüz otuz bir', 'dokuz yüz otuz iki', 'dokuz yüz otuz üç', 'dokuz yüz otuz dört', 'dokuz yüz otuz beş', 'dokuz yüz otuz altı', 'dokuz yüz otuz yedi', 'dokuz yüz otuz sekiz', 'dokuz yüz otuz dokuz', 'dokuz yüz kırk', 'dokuz yüz kırk bir', 'dokuz yüz kırk iki', 'dokuz yüz kırk üç', 'dokuz yüz kırk dört', 'dokuz yüz kırk beş', 'dokuz yüz kırk altı', 'dokuz yüz kırk yedi', 'dokuz yüz kırk sekiz', 'dokuz yüz kırk dokuz', 'dokuz yüz elli', 'dokuz yüz elli bir', 'dokuz yüz elli iki', 'dokuz yüz elli üç', 'dokuz yüz elli dört', 'dokuz yüz elli beş', 'dokuz yüz elli altı', 'dokuz yüz elli yedi', 'dokuz yüz elli sekiz', 'dokuz yüz elli dokuz', 'dokuz yüz altmış', 'dokuz yüz altmış bir', 'dokuz yüz altmış iki', 'dokuz yüz altmış üç', 'dokuz yüz altmış dört', 'dokuz yüz altmış beş', 'dokuz yüz altmış altı', 'dokuz yüz altmış yedi', 'dokuz yüz altmış sekiz', 'dokuz yüz altmış dokuz', 'dokuz yüz yetmiş', 'dokuz yüz yetmiş bir', 'dokuz yüz yetmiş iki', 'dokuz yüz yetmiş üç', 'dokuz yüz yetmiş dört', 'dokuz yüz yetmiş beş', 'dokuz yüz yetmiş altı', 'dokuz yüz yetmiş yedi', 'dokuz yüz yetmiş sekiz', 'dokuz yüz yetmiş dokuz', 'dokuz yüz seksen', 'dokuz yüz seksen bir', 'dokuz yüz seksen iki', 'dokuz yüz seksen üç', 'dokuz yüz seksen dört', 'dokuz yüz seksen beş', 'dokuz yüz seksen altı', 'dokuz yüz seksen yedi', 'dokuz yüz seksen sekiz', 'dokuz yüz seksen dokuz', 'dokuz yüz doksan', 'dokuz yüz doksan bir', 'dokuz yüz doksan iki', 'dokuz yüz doksan üç', 'dokuz yüz doksan dört', 'dokuz yüz doksan beş', 'dokuz yüz doksan altı', 'dokuz yüz doksan yedi', 'dokuz yüz doksan sekiz', 'dokuz yüz doksan dokuz'].freeze
  end
end
